"use strict";
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const QRCode = require("qrcode");
function noop() {
}
function is_promise(value) {
  return !!value && (typeof value === "object" || typeof value === "function") && typeof /** @type {any} */
  value.then === "function";
}
function run(fn) {
  return fn();
}
function blank_object() {
  return /* @__PURE__ */ Object.create(null);
}
function run_all(fns) {
  fns.forEach(run);
}
function safe_not_equal(a, b) {
  return a != a ? b == b : a !== b || a && typeof a === "object" || typeof a === "function";
}
function subscribe(store, ...callbacks) {
  if (store == null) {
    for (const callback of callbacks) {
      callback(void 0);
    }
    return noop;
  }
  const unsub = store.subscribe(...callbacks);
  return unsub.unsubscribe ? () => unsub.unsubscribe() : unsub;
}
let current_component;
function set_current_component(component) {
  current_component = component;
}
function get_current_component() {
  if (!current_component) throw new Error("Function called outside component initialization");
  return current_component;
}
function setContext(key, context) {
  get_current_component().$$.context.set(key, context);
  return context;
}
function getContext(key) {
  return get_current_component().$$.context.get(key);
}
function ensure_array_like(array_like_or_iterator) {
  return (array_like_or_iterator == null ? void 0 : array_like_or_iterator.length) !== void 0 ? array_like_or_iterator : Array.from(array_like_or_iterator);
}
const _boolean_attributes = (
  /** @type {const} */
  [
    "allowfullscreen",
    "allowpaymentrequest",
    "async",
    "autofocus",
    "autoplay",
    "checked",
    "controls",
    "default",
    "defer",
    "disabled",
    "formnovalidate",
    "hidden",
    "inert",
    "ismap",
    "loop",
    "multiple",
    "muted",
    "nomodule",
    "novalidate",
    "open",
    "playsinline",
    "readonly",
    "required",
    "reversed",
    "selected"
  ]
);
const boolean_attributes = /* @__PURE__ */ new Set([..._boolean_attributes]);
const ATTR_REGEX = /[&"<]/g;
const CONTENT_REGEX = /[&<]/g;
function escape(value, is_attr = false) {
  const str = String(value);
  const pattern = is_attr ? ATTR_REGEX : CONTENT_REGEX;
  pattern.lastIndex = 0;
  let escaped = "";
  let last = 0;
  while (pattern.test(str)) {
    const i = pattern.lastIndex - 1;
    const ch = str[i];
    escaped += str.substring(last, i) + (ch === "&" ? "&amp;" : ch === '"' ? "&quot;" : "&lt;");
    last = i + 1;
  }
  return escaped + str.substring(last);
}
const invalid_attribute_name_character = /[\s'">/=\u{FDD0}-\u{FDEF}\u{FFFE}\u{FFFF}\u{1FFFE}\u{1FFFF}\u{2FFFE}\u{2FFFF}\u{3FFFE}\u{3FFFF}\u{4FFFE}\u{4FFFF}\u{5FFFE}\u{5FFFF}\u{6FFFE}\u{6FFFF}\u{7FFFE}\u{7FFFF}\u{8FFFE}\u{8FFFF}\u{9FFFE}\u{9FFFF}\u{AFFFE}\u{AFFFF}\u{BFFFE}\u{BFFFF}\u{CFFFE}\u{CFFFF}\u{DFFFE}\u{DFFFF}\u{EFFFE}\u{EFFFF}\u{FFFFE}\u{FFFFF}\u{10FFFE}\u{10FFFF}]/u;
function spread(args, attrs_to_add) {
  const attributes = Object.assign({}, ...args);
  if (attrs_to_add) {
    const classes_to_add = attrs_to_add.classes;
    const styles_to_add = attrs_to_add.styles;
    if (classes_to_add) {
      if (attributes.class == null) {
        attributes.class = classes_to_add;
      } else {
        attributes.class += " " + classes_to_add;
      }
    }
    if (styles_to_add) {
      if (attributes.style == null) {
        attributes.style = style_object_to_string(styles_to_add);
      } else {
        attributes.style = style_object_to_string(
          merge_ssr_styles(attributes.style, styles_to_add)
        );
      }
    }
  }
  let str = "";
  Object.keys(attributes).forEach((name) => {
    if (invalid_attribute_name_character.test(name)) return;
    const value = attributes[name];
    if (value === true) str += " " + name;
    else if (boolean_attributes.has(name.toLowerCase())) {
      if (value) str += " " + name;
    } else if (value != null) {
      str += ` ${name}="${value}"`;
    }
  });
  return str;
}
function merge_ssr_styles(style_attribute, style_directive) {
  const style_object = {};
  for (const individual_style of style_attribute.split(";")) {
    const colon_index = individual_style.indexOf(":");
    const name = individual_style.slice(0, colon_index).trim();
    const value = individual_style.slice(colon_index + 1).trim();
    if (!name) continue;
    style_object[name] = value;
  }
  for (const name in style_directive) {
    const value = style_directive[name];
    if (value) {
      style_object[name] = value;
    } else {
      delete style_object[name];
    }
  }
  return style_object;
}
function escape_attribute_value(value) {
  const should_escape = typeof value === "string" || value && typeof value === "object";
  return should_escape ? escape(value, true) : value;
}
function escape_object(obj) {
  const result = {};
  for (const key in obj) {
    result[key] = escape_attribute_value(obj[key]);
  }
  return result;
}
function each(items, fn) {
  items = ensure_array_like(items);
  let str = "";
  for (let i = 0; i < items.length; i += 1) {
    str += fn(items[i], i);
  }
  return str;
}
const missing_component = {
  $$render: () => ""
};
function validate_component(component, name) {
  if (!component || !component.$$render) {
    if (name === "svelte:component") name += " this={...}";
    throw new Error(
      `<${name}> is not a valid SSR component. You may need to review your build config to ensure that dependencies are compiled, rather than imported as pre-compiled modules. Otherwise you may need to fix a <${name}>.`
    );
  }
  return component;
}
let on_destroy;
function create_ssr_component(fn) {
  function $$render(result, props, bindings, slots, context) {
    const parent_component = current_component;
    const $$ = {
      on_destroy,
      context: new Map(context || (parent_component ? parent_component.$$.context : [])),
      // these will be immediately discarded
      on_mount: [],
      before_update: [],
      after_update: [],
      callbacks: blank_object()
    };
    set_current_component({ $$ });
    const html = fn(result, props, bindings, slots);
    set_current_component(parent_component);
    return html;
  }
  return {
    render: (props = {}, { $$slots = {}, context = /* @__PURE__ */ new Map() } = {}) => {
      on_destroy = [];
      const result = { title: "", head: "", css: /* @__PURE__ */ new Set() };
      const html = $$render(result, props, {}, $$slots, context);
      run_all(on_destroy);
      return {
        html,
        css: {
          code: Array.from(result.css).map((css2) => css2.code).join("\n"),
          map: null
          // TODO
        },
        head: result.title + result.head
      };
    },
    $$render
  };
}
function add_attribute(name, value, boolean) {
  if (value == null || boolean) return "";
  const assignment = `="${escape(value, true)}"`;
  return ` ${name}${assignment}`;
}
function style_object_to_string(style_object) {
  return Object.keys(style_object).filter((key) => style_object[key] != null && style_object[key] !== "").map((key) => `${key}: ${escape_attribute_value(style_object[key])};`).join(" ");
}
const contextKey = "pdfmake-document";
function getDocument() {
  return getContext(contextKey).document;
}
function getDocumentNodes() {
  return getContext(contextKey).nodes;
}
const css$g = {
  code: "span.phr-15ezjjc{font-size:0}span.phr-15ezjjc>*{font-size:var(--font-size)}p.phr-15ezjjc{margin:0}",
  map: `{"version":3,"file":"ContentArrayRenderer.svelte","sources":["ContentArrayRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">import ContentRenderer from './ContentRenderer.svelte';\\nexport let node;\\nexport let inline = false;\\nexport let first = true;\\nexport let last = true;\\n<\/script>\\n\\n{#if inline}\\n  <span>\\n    {#each node as entry, i}\\n      <ContentRenderer\\n        node={entry}\\n        inline\\n        first={first && i === 0}\\n        last={last && i === node.length - 1}\\n      />\\n    {/each}\\n  </span>\\n{:else}\\n  {#each node as entry}\\n    <p>\\n      <ContentRenderer node={entry} />\\n    </p>\\n  {/each}\\n{/if}\\n\\n<style>\\n  span {\\n    /* Prevent whitespace between inline nodes */\\n    font-size: 0;\\n  }\\n  span > :global(*) {\\n    font-size: var(--font-size);\\n  }\\n\\n  p {\\n    margin: 0;\\n  }\\n</style>\\n"],"names":[],"mappings":"AA2BE,gBAAK,CAEH,SAAS,CAAE,CACb,CACA,gBAAI,CAAW,CAAG,CAChB,SAAS,CAAE,IAAI,WAAW,CAC5B,CAEA,aAAE,CACA,MAAM,CAAE,CACV"}`
};
const ContentArrayRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let { node } = $$props;
  let { inline = false } = $$props;
  let { first = true } = $$props;
  let { last = true } = $$props;
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  if ($$props.inline === void 0 && $$bindings.inline && inline !== void 0) $$bindings.inline(inline);
  if ($$props.first === void 0 && $$bindings.first && first !== void 0) $$bindings.first(first);
  if ($$props.last === void 0 && $$bindings.last && last !== void 0) $$bindings.last(last);
  $$result.css.add(css$g);
  return `${inline ? `<span class="phr-15ezjjc">${each(node, (entry, i) => {
    return `${validate_component(ContentRenderer, "ContentRenderer").$$render(
      $$result,
      {
        node: entry,
        inline: true,
        first: first && i === 0,
        last: last && i === node.length - 1
      },
      {},
      {}
    )}`;
  })}</span>` : `${each(node, (entry) => {
    return `<p class="phr-15ezjjc">${validate_component(ContentRenderer, "ContentRenderer").$$render($$result, { node: entry }, {}, {})} </p>`;
  })}`}`;
});
const css$f = {
  code: "span.phr-1w9tdvi{white-space:var(--white-space, pre-wrap)}",
  map: `{"version":3,"file":"StringRenderer.svelte","sources":["StringRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">export let node;\\nexport let first = true;\\nexport let last = true;\\n// Cannot reference node inside the function, as Svelte's reactivity won't re-render\\nfunction trimText(myNode) {\\n    if (typeof myNode !== 'string')\\n        return myNode;\\n    if (!first && !last)\\n        return myNode;\\n    let text = myNode;\\n    // we cannot just trim(), as we need to preserve newlines\\n    if (first)\\n        text = text.replace(/^(\\\\n*) +/, '$1');\\n    if (last)\\n        text = text.replace(/ +$/, '');\\n    // spaces can be used to create empty lines\\n    if (myNode !== '' && text === '')\\n        return ' ';\\n    return text;\\n}\\n<\/script>\\n\\n<span>{trimText(node)}</span>\\n\\n<style>\\n  span {\\n    white-space: var(--white-space, pre-wrap);\\n  }\\n</style>\\n"],"names":[],"mappings":"AAyBE,gBAAK,CACH,WAAW,CAAE,IAAI,aAAa,CAAC,SAAS,CAC1C"}`
};
const StringRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let { node } = $$props;
  let { first = true } = $$props;
  let { last = true } = $$props;
  function trimText(myNode) {
    if (typeof myNode !== "string") return myNode;
    if (!first && !last) return myNode;
    let text = myNode;
    if (first) text = text.replace(/^(\n*) +/, "$1");
    if (last) text = text.replace(/ +$/, "");
    if (myNode !== "" && text === "") return " ";
    return text;
  }
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  if ($$props.first === void 0 && $$bindings.first && first !== void 0) $$bindings.first(first);
  if ($$props.last === void 0 && $$bindings.last && last !== void 0) $$bindings.last(last);
  $$result.css.add(css$f);
  return `<span class="phr-1w9tdvi">${escape(trimText(node))}</span>`;
});
const ContentTextRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let { node } = $$props;
  let { first = true } = $$props;
  let { last = true } = $$props;
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  if ($$props.first === void 0 && $$bindings.first && first !== void 0) $$bindings.first(first);
  if ($$props.last === void 0 && $$bindings.last && last !== void 0) $$bindings.last(last);
  return `${Array.isArray(node.text) ? `${validate_component(ContentArrayRenderer, "ContentArrayRenderer").$$render(
    $$result,
    {
      node: node.text,
      inline: true,
      first: first && !node.preserveLeadingSpaces,
      last: last && !node.preserveTrailingSpaces
    },
    {},
    {}
  )}` : `${typeof node.text === "string" || typeof node.text === "number" ? `${node.text !== "" ? `${validate_component(StringRenderer, "StringRenderer").$$render(
    $$result,
    {
      node: node.text,
      first: first && !node.preserveLeadingSpaces,
      last: last && !node.preserveTrailingSpaces
    },
    {},
    {}
  )}` : ``}` : `${validate_component(ContentRenderer, "ContentRenderer").$$render(
    $$result,
    {
      node: node.text,
      first: first && !node.preserveLeadingSpaces,
      last: last && !node.preserveTrailingSpaces
    },
    {},
    {}
  )}`}`}`;
});
function getSize(input) {
  if (typeof input === "number" || /^[\d.]+$/.test(input)) {
    return input + "pt";
  } else if (input.includes("%")) {
    return input;
  }
  return parseFloat(input) + "pt";
}
const cssColorNames = {
  aliceblue: "#f0f8ff",
  antiquewhite: "#faebd7",
  aqua: "#00ffff",
  aquamarine: "#7fffd4",
  azure: "#f0ffff",
  beige: "#f5f5dc",
  bisque: "#ffe4c4",
  black: "#000000",
  blanchedalmond: "#ffebcd",
  blue: "#0000ff",
  blueviolet: "#8a2be2",
  brown: "#a52a2a",
  burlywood: "#deb887",
  cadetblue: "#5f9ea0",
  chartreuse: "#7fff00",
  chocolate: "#d2691e",
  coral: "#ff7f50",
  cornflowerblue: "#6495ed",
  cornsilk: "#fff8dc",
  crimson: "#dc143c",
  cyan: "#00ffff",
  darkblue: "#00008b",
  darkcyan: "#008b8b",
  darkgoldenrod: "#b8860b",
  darkgray: "#a9a9a9",
  darkgreen: "#006400",
  darkgrey: "#a9a9a9",
  darkkhaki: "#bdb76b",
  darkmagenta: "#8b008b",
  darkolivegreen: "#556b2f",
  darkorange: "#ff8c00",
  darkorchid: "#9932cc",
  darkred: "#8b0000",
  darksalmon: "#e9967a",
  darkseagreen: "#8fbc8f",
  darkslateblue: "#483d8b",
  darkslategray: "#2f4f4f",
  darkslategrey: "#2f4f4f",
  darkturquoise: "#00ced1",
  darkviolet: "#9400d3",
  deeppink: "#ff1493",
  deepskyblue: "#00bfff",
  dimgray: "#696969",
  dimgrey: "#696969",
  dodgerblue: "#1e90ff",
  firebrick: "#b22222",
  floralwhite: "#fffaf0",
  forestgreen: "#228b22",
  fuchsia: "#ff00ff",
  gainsboro: "#dcdcdc",
  ghostwhite: "#f8f8ff",
  goldenrod: "#daa520",
  gold: "#ffd700",
  gray: "#808080",
  green: "#008000",
  greenyellow: "#adff2f",
  grey: "#808080",
  honeydew: "#f0fff0",
  hotpink: "#ff69b4",
  indianred: "#cd5c5c",
  indigo: "#4b0082",
  ivory: "#fffff0",
  khaki: "#f0e68c",
  lavenderblush: "#fff0f5",
  lavender: "#e6e6fa",
  lawngreen: "#7cfc00",
  lemonchiffon: "#fffacd",
  lightblue: "#add8e6",
  lightcoral: "#f08080",
  lightcyan: "#e0ffff",
  lightgoldenrodyellow: "#fafad2",
  lightgray: "#d3d3d3",
  lightgreen: "#90ee90",
  lightgrey: "#d3d3d3",
  lightpink: "#ffb6c1",
  lightsalmon: "#ffa07a",
  lightseagreen: "#20b2aa",
  lightskyblue: "#87cefa",
  lightslategray: "#778899",
  lightslategrey: "#778899",
  lightsteelblue: "#b0c4de",
  lightyellow: "#ffffe0",
  lime: "#00ff00",
  limegreen: "#32cd32",
  linen: "#faf0e6",
  magenta: "#ff00ff",
  maroon: "#800000",
  mediumaquamarine: "#66cdaa",
  mediumblue: "#0000cd",
  mediumorchid: "#ba55d3",
  mediumpurple: "#9370db",
  mediumseagreen: "#3cb371",
  mediumslateblue: "#7b68ee",
  mediumspringgreen: "#00fa9a",
  mediumturquoise: "#48d1cc",
  mediumvioletred: "#c71585",
  midnightblue: "#191970",
  mintcream: "#f5fffa",
  mistyrose: "#ffe4e1",
  moccasin: "#ffe4b5",
  navajowhite: "#ffdead",
  navy: "#000080",
  oldlace: "#fdf5e6",
  olive: "#808000",
  olivedrab: "#6b8e23",
  orange: "#ffa500",
  orangered: "#ff4500",
  orchid: "#da70d6",
  palegoldenrod: "#eee8aa",
  palegreen: "#98fb98",
  paleturquoise: "#afeeee",
  palevioletred: "#db7093",
  papayawhip: "#ffefd5",
  peachpuff: "#ffdab9",
  peru: "#cd853f",
  pink: "#ffc0cb",
  plum: "#dda0dd",
  powderblue: "#b0e0e6",
  purple: "#800080",
  rebeccapurple: "#663399",
  red: "#ff0000",
  rosybrown: "#bc8f8f",
  royalblue: "#4169e1",
  saddlebrown: "#8b4513",
  salmon: "#fa8072",
  sandybrown: "#f4a460",
  seagreen: "#2e8b57",
  seashell: "#fff5ee",
  sienna: "#a0522d",
  silver: "#c0c0c0",
  skyblue: "#87ceeb",
  slateblue: "#6a5acd",
  slategray: "#708090",
  slategrey: "#708090",
  snow: "#fffafa",
  springgreen: "#00ff7f",
  steelblue: "#4682b4",
  tan: "#d2b48c",
  teal: "#008080",
  thistle: "#d8bfd8",
  tomato: "#ff6347",
  turquoise: "#40e0d0",
  violet: "#ee82ee",
  wheat: "#f5deb3",
  white: "#ffffff",
  whitesmoke: "#f5f5f5",
  yellow: "#ffff00",
  yellowgreen: "#9acd32"
};
function getStyleString(styles) {
  return Object.entries(styles).map(([key, value]) => `${key}: ${value}`).join("; ");
}
function colorToHex(color) {
  var _a;
  if (color === "transparent") return void 0;
  if (!color || color.startsWith("#")) return color;
  return (_a = cssColorNames[color]) != null ? _a : void 0;
}
function colorToRgb(color) {
  if (!color || Array.isArray(color) || color === "transparent")
    return void 0;
  const hexColor = colorToHex(color);
  if (!hexColor) return void 0;
  return [
    parseInt(hexColor.slice(1, 3), 16),
    parseInt(hexColor.slice(3, 5), 16),
    parseInt(hexColor.slice(5), 16)
  ];
}
function opacityColor(color, opacity) {
  if (color == null || Array.isArray(color)) return void 0;
  if (opacity == null || opacity == 1) return color;
  if (opacity == 0) return "transparent";
  const rgb = colorToRgb(color);
  if (!rgb) return color;
  return `rgba(${rgb.join(", ")}, ${opacity})`;
}
function getColumnStyleString(node) {
  const starWidthStyle = {
    "flex-basis": 0,
    "flex-grow": 1
  };
  const styles = {
    "flex-grow": "0",
    "flex-shrink": "1",
    margin: `0 var(--column-gap, '0')`
  };
  if (typeof node !== "object" || Array.isArray(node)) {
    Object.assign(styles, starWidthStyle);
  } else {
    const column = node;
    if (column.width === "auto") ;
    else if (column.width === void 0 || column.width === "*") {
      Object.assign(styles, starWidthStyle);
    } else {
      styles.width = getSize(column.width);
    }
  }
  return getStyleString(styles);
}
const css$e = {
  code: ".phr-container.phr-1qd8b3h{display:flex;margin:0 calc(-1 * var(--column-gap))}",
  map: `{"version":3,"file":"ContentColumnsRenderer.svelte","sources":["ContentColumnsRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">import ContentRenderer from './ContentRenderer.svelte';\\nimport { getColumnStyleString } from '../styling/column';\\nexport let node;\\n<\/script>\\n\\n<div class=\\"phr-container\\">\\n  {#each node.columns as column}\\n    <div style={getColumnStyleString(column)}>\\n      <ContentRenderer node={column} />\\n    </div>\\n  {/each}\\n</div>\\n\\n<style>\\n  .phr-container {\\n    display: flex;\\n    margin: 0 calc(-1 * var(--column-gap));\\n  }\\n</style>\\n"],"names":[],"mappings":"AAcE,0BAAe,CACb,OAAO,CAAE,IAAI,CACb,MAAM,CAAE,CAAC,CAAC,KAAK,EAAE,CAAC,CAAC,CAAC,IAAI,YAAY,CAAC,CACvC"}`
};
const ContentColumnsRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let { node } = $$props;
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  $$result.css.add(css$e);
  return `<div class="phr-container phr-1qd8b3h">${each(node.columns, (column) => {
    return `<div${add_attribute("style", getColumnStyleString(column), 0)}>${validate_component(ContentRenderer, "ContentRenderer").$$render($$result, { node: column }, {}, {})} </div>`;
  })} </div>`;
});
const ContentStackRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let { node } = $$props;
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  return `${validate_component(ContentArrayRenderer, "ContentArrayRenderer").$$render($$result, { node: node.stack }, {}, {})}`;
});
function isActualTableCell(cell) {
  return cell !== "" && Boolean(Object.keys(cell).length);
}
function getTableCellsCoveredBySpans(node) {
  var _a, _b;
  const coveredCells = /* @__PURE__ */ new Set();
  (_b = (_a = node.table) == null ? void 0 : _a.body) == null ? void 0 : _b.forEach((row, rowIndex) => {
    row.forEach((column, columnIndex) => {
      var _a2, _b2;
      if (isActualTableCell(column)) {
        if (column.rowSpan && column.rowSpan > 1 || column.colSpan && column.colSpan > 1) {
          for (let i = 0; i < ((_a2 = column.rowSpan) != null ? _a2 : 1); i++) {
            for (let j = 0; j < ((_b2 = column.colSpan) != null ? _b2 : 1); j++) {
              if (i !== 0 || j !== 0)
                coveredCells.add(`${rowIndex + i}-${columnIndex + j}`);
            }
          }
        }
      }
    });
  });
  return coveredCells;
}
function shouldRenderCell(cell, rowIndex, columnIndex, coveredCells) {
  return !coveredCells.has(`${rowIndex}-${columnIndex}`);
}
function getTableStyleString(node) {
  if (!node.table.widths) return void 0;
  const style = {};
  if (node.table.widths) {
    if (node.table.widths === "*") {
      style["table-layout"] = "fixed";
      style["width"] = "100%";
    } else if (Array.isArray(node.table.widths) && node.table.widths.includes("*")) {
      style["width"] = "100%";
    }
  }
  return getStyleString(style);
}
function getTableCellStyleString(node, table, rowIndex, columnIndex) {
  const style = {};
  if (Array.isArray(table.table.widths)) {
    const columnWidth = table.table.widths[columnIndex];
    if (columnWidth !== void 0 && columnWidth !== "auto" && columnWidth !== "*") {
      const width = getSize(columnWidth);
      style.width = width;
      style["max-width"] = width;
    }
  }
  if (typeof table.table.heights === "number") {
    style.height = table.table.heights + "pt";
  } else if (Array.isArray(table.table.heights)) {
    const height = table.table.heights[rowIndex];
    if (height !== void 0) style.height = height + "pt";
  } else if (typeof table.table.heights === "function") {
    const height = table.table.heights(rowIndex);
    if (height != null && height !== "auto") style.height = height + "pt";
  }
  if (typeof table.layout === "object" && table.layout) {
    const normalizedTable = __spreadProps(__spreadValues({}, table), {
      table: __spreadValues({}, table.table)
    });
    if (!Array.isArray(table.table.widths)) {
      normalizedTable.table.widths = Array.isArray(table.table.body) ? table.table.body[0].map(() => "auto") : "auto";
    }
    const lineLayoutProperty = (key, horizontal, callback) => {
      const property = table.layout[key];
      if (typeof property === "string") {
        callback(property, property);
      } else if (typeof property === "function") {
        try {
          const val1 = property(
            horizontal ? rowIndex : columnIndex,
            normalizedTable,
            horizontal ? columnIndex : rowIndex
          );
          const val2 = property(
            horizontal ? rowIndex + 1 : columnIndex + 1,
            normalizedTable,
            horizontal ? columnIndex : rowIndex
          );
          callback(val1, val2);
        } catch (e) {
        }
      }
    };
    lineLayoutProperty("hLineWidth", true, (top, bottom) => {
      style["border-top-width"] = (top != null ? top : 0) + "pt";
      style["border-bottom-width"] = (bottom != null ? bottom : 0) + "pt";
    });
    lineLayoutProperty("hLineColor", true, (top, bottom) => {
      if (top != null) style["border-top-color"] = top;
      if (bottom != null) style["border-bottom-color"] = bottom;
    });
    lineLayoutProperty("hLineStyle", true, (top, bottom) => {
      if (top != null && top.dash) style["border-top-style"] = "dashed";
      if (bottom != null && bottom.dash) style["border-bottom-style"] = "dashed";
    });
    lineLayoutProperty("vLineWidth", false, (left, right) => {
      if (left != null) style["border-left-width"] = left + "pt";
      if (right != null) style["border-right-width"] = right + "pt";
    });
    lineLayoutProperty("vLineColor", false, (left, right) => {
      if (left != null) style["border-left-color"] = left;
      if (right != null) style["border-right-color"] = right;
    });
    lineLayoutProperty("vLineStyle", false, (left, right) => {
      if (left != null && left.dash) style["border-left-style"] = "dashed";
      if (right != null && right.dash) style["border-right-style"] = "dashed";
    });
    const cellLayoutProperty = (key, horizontal, callback) => {
      const property = table.layout[key];
      if (typeof property === "string" || typeof property === "number") {
        callback(property);
      } else if (typeof property === "function") {
        try {
          const value = property(
            horizontal ? rowIndex : columnIndex,
            normalizedTable,
            horizontal ? columnIndex : rowIndex
          );
          callback(value);
        } catch (e) {
        }
      }
    };
    cellLayoutProperty("paddingLeft", false, (value) => {
      style["padding-left"] = (value != null ? value : 0) + "pt";
    });
    cellLayoutProperty("paddingRight", false, (value) => {
      style["padding-right"] = (value != null ? value : 0) + "pt";
    });
    cellLayoutProperty("paddingTop", true, (value) => {
      style["padding-top"] = (value != null ? value : 0) + "pt";
    });
    cellLayoutProperty("paddingBottom", true, (value) => {
      style["padding-bottom"] = (value != null ? value : 0) + "pt";
    });
    let fillColor = null;
    let fillOpacity = null;
    cellLayoutProperty("fillColor", true, (value) => {
      if (value != null) fillColor = value;
    });
    cellLayoutProperty("fillOpacity", true, (value) => {
      if (value != null) fillOpacity = value;
    });
    if (fillColor) {
      const fillColorRgb = colorToRgb(fillColor);
      if (fillColorRgb) {
        style["--fill-color"] = fillColorRgb.join(", ");
        style["--fill-opacity"] = "1";
      }
    }
    if (fillOpacity != null) style["--fill-opacity"] = String(fillOpacity);
    if (table.layout.defaultBorder === false) {
      style["border-style"] = "none";
    }
  }
  if (typeof node === "object" && node) {
    if ("noWrap" in node && node.noWrap) {
      style["white-space"] = "nowrap";
      style["--white-space"] = "nowrap";
    }
    if ("fillColor" in node && node.fillColor) {
      const fillColorRgb = colorToRgb(node.fillColor);
      if (fillColorRgb) {
        style["--fill-color"] = fillColorRgb.join(", ");
        style["--fill-opacity"] = "1";
      }
    }
    if ("fillOpacity" in node)
      style["--fill-opacity"] = String(node.fillOpacity);
    if ("border" in node && node.border) {
      const [left, top, right, bottom] = node.border;
      style["border-left-style"] = left ? "solid" : "none";
      style["border-top-style"] = top ? "solid" : "none";
      style["border-bottom-style"] = bottom ? "solid" : "none";
      style["border-right-style"] = right ? "solid" : "none";
    }
    if ("borderColor" in node && node.borderColor) {
      const [left, top, right, bottom] = node.borderColor;
      if (left) style["border-left-color"] = left;
      if (top) style["border-top-color"] = top;
      if (bottom) style["border-bottom-color"] = bottom;
      if (right) style["border-right-color"] = right;
    }
  }
  return getStyleString(style);
}
const css$d = {
  code: "td.phr-1h5exwf.phr-1h5exwf.phr-1h5exwf{border:1px solid #000;padding:2pt 4pt;vertical-align:top;background:rgba(var(--fill-color), var(--fill-opacity, 0))}table.phr-1h5exwf.phr-1h5exwf.phr-1h5exwf{border-collapse:collapse;text-indent:inherit}.phr-noSidePadding.phr-1h5exwf>tr.phr-1h5exwf>td.phr-1h5exwf:first-child{padding-left:0}.phr-noSidePadding.phr-1h5exwf>tr.phr-1h5exwf>td.phr-1h5exwf:last-child{padding-right:0}.phr-noBorders.phr-1h5exwf>tr.phr-1h5exwf>td.phr-1h5exwf{border:none}.phr-headerLineOnly.phr-1h5exwf>.phr-header.phr-1h5exwf.phr-1h5exwf{border-bottom:2pt solid #000}.phr-headerLineOnly.phr-1h5exwf>tr.phr-1h5exwf>td.phr-1h5exwf{border:none;padding-left:8pt;padding-right:8pt}.phr-lightHorizontalLines.phr-1h5exwf>.phr-header.phr-1h5exwf>td.phr-1h5exwf{border-bottom-width:2pt}.phr-lightHorizontalLines.phr-1h5exwf>tr.phr-1h5exwf>td.phr-1h5exwf{border-left:none;border-right:none;border-top:none;border-bottom-color:#aaa;padding-left:8pt;padding-right:8pt}.phr-lightHorizontalLines.phr-1h5exwf>tr.phr-1h5exwf:first-child>td.phr-1h5exwf{border-bottom-color:#000}.phr-lightHorizontalLines.phr-1h5exwf>tr.phr-1h5exwf:last-child>td.phr-1h5exwf{border-bottom:none}",
  map: `{"version":3,"file":"ContentTableRenderer.svelte","sources":["ContentTableRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">import { getTableCellsCoveredBySpans, isActualTableCell, shouldRenderCell, } from '../logic/table';\\nimport { getTableCellStyleString, getTableStyleString, } from '../styling/table';\\nimport ContentRenderer from './ContentRenderer.svelte';\\nexport let node;\\n$: coveredCells = getTableCellsCoveredBySpans(node);\\n<\/script>\\n\\n<table\\n  style={getTableStyleString(node)}\\n  class:phr-noBorders={node.layout === 'noBorders'}\\n  class:phr-headerLineOnly={node.layout === 'headerLineOnly'}\\n  class:phr-lightHorizontalLines={node.layout === 'lightHorizontalLines'}\\n  class:phr-noSidePadding={node.layout === 'noBorders' ||\\n    node.layout === 'headerLineOnly' ||\\n    node.layout === 'lightHorizontalLines'}\\n>\\n  {#each node.table?.body ?? [] as tr, rowIndex}\\n    <tr\\n      class:phr-header={(node.table.headerRows ?? -1) === rowIndex + 1 &&\\n        rowIndex < (node.table?.body.length ?? 0) - 1}\\n    >\\n      {#each tr as td, columnIndex}\\n        {#if shouldRenderCell(td, rowIndex, columnIndex, coveredCells)}\\n          <td\\n            colspan={td.colSpan}\\n            rowspan={td.rowSpan}\\n            style={getTableCellStyleString(td, node, rowIndex, columnIndex)}\\n          >\\n            {#if isActualTableCell(td)}\\n              <ContentRenderer node={td} />\\n            {/if}\\n          </td>\\n        {/if}\\n      {/each}\\n    </tr>\\n  {/each}\\n</table>\\n\\n<style>\\n  td {\\n    border: 1px solid #000;\\n    padding: 2pt 4pt;\\n    vertical-align: top;\\n    background: rgba(var(--fill-color), var(--fill-opacity, 0));\\n  }\\n  table {\\n    border-collapse: collapse;\\n    text-indent: inherit;\\n  }\\n\\n  /* table layouts */\\n\\n  .phr-noSidePadding > tr > td:first-child {\\n    padding-left: 0;\\n  }\\n  .phr-noSidePadding > tr > td:last-child {\\n    padding-right: 0;\\n  }\\n\\n  .phr-noBorders > tr > td {\\n    border: none;\\n  }\\n\\n  .phr-headerLineOnly > .phr-header {\\n    border-bottom: 2pt solid #000;\\n  }\\n\\n  .phr-headerLineOnly > tr > td {\\n    border: none;\\n    padding-left: 8pt;\\n    padding-right: 8pt;\\n  }\\n\\n  .phr-lightHorizontalLines > .phr-header > td {\\n    border-bottom-width: 2pt;\\n  }\\n\\n  .phr-lightHorizontalLines > tr > td {\\n    border-left: none;\\n    border-right: none;\\n    border-top: none;\\n    border-bottom-color: #aaa;\\n    padding-left: 8pt;\\n    padding-right: 8pt;\\n  }\\n\\n  .phr-lightHorizontalLines > tr:first-child > td {\\n    border-bottom-color: #000;\\n  }\\n\\n  .phr-lightHorizontalLines > tr:last-child > td {\\n    border-bottom: none;\\n  }\\n</style>\\n"],"names":[],"mappings":"AAuCE,sCAAG,CACD,MAAM,CAAE,GAAG,CAAC,KAAK,CAAC,IAAI,CACtB,OAAO,CAAE,GAAG,CAAC,GAAG,CAChB,cAAc,CAAE,GAAG,CACnB,UAAU,CAAE,KAAK,IAAI,YAAY,CAAC,CAAC,CAAC,IAAI,cAAc,CAAC,EAAE,CAAC,CAC5D,CACA,yCAAM,CACJ,eAAe,CAAE,QAAQ,CACzB,WAAW,CAAE,OACf,CAIA,8BAAkB,CAAG,cAAE,CAAG,cAAE,YAAa,CACvC,YAAY,CAAE,CAChB,CACA,8BAAkB,CAAG,cAAE,CAAG,cAAE,WAAY,CACtC,aAAa,CAAE,CACjB,CAEA,0BAAc,CAAG,cAAE,CAAG,cAAG,CACvB,MAAM,CAAE,IACV,CAEA,+BAAmB,CAAG,mCAAY,CAChC,aAAa,CAAE,GAAG,CAAC,KAAK,CAAC,IAC3B,CAEA,+BAAmB,CAAG,cAAE,CAAG,cAAG,CAC5B,MAAM,CAAE,IAAI,CACZ,YAAY,CAAE,GAAG,CACjB,aAAa,CAAE,GACjB,CAEA,qCAAyB,CAAG,uBAAW,CAAG,cAAG,CAC3C,mBAAmB,CAAE,GACvB,CAEA,qCAAyB,CAAG,cAAE,CAAG,cAAG,CAClC,WAAW,CAAE,IAAI,CACjB,YAAY,CAAE,IAAI,CAClB,UAAU,CAAE,IAAI,CAChB,mBAAmB,CAAE,IAAI,CACzB,YAAY,CAAE,GAAG,CACjB,aAAa,CAAE,GACjB,CAEA,qCAAyB,CAAG,cAAE,YAAY,CAAG,cAAG,CAC9C,mBAAmB,CAAE,IACvB,CAEA,qCAAyB,CAAG,cAAE,WAAW,CAAG,cAAG,CAC7C,aAAa,CAAE,IACjB"}`
};
const ContentTableRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  var _a, _b;
  let coveredCells;
  let { node } = $$props;
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  $$result.css.add(css$d);
  coveredCells = getTableCellsCoveredBySpans(node);
  return `<table${add_attribute("style", getTableStyleString(node), 0)} class="${[
    "phr-1h5exwf",
    (node.layout === "noBorders" ? "phr-noBorders" : "") + " " + (node.layout === "headerLineOnly" ? "phr-headerLineOnly" : "") + " " + (node.layout === "lightHorizontalLines" ? "phr-lightHorizontalLines" : "") + " " + (node.layout === "noBorders" || node.layout === "headerLineOnly" || node.layout === "lightHorizontalLines" ? "phr-noSidePadding" : "")
  ].join(" ").trim()}">${each((_b = (_a = node.table) == null ? void 0 : _a.body) != null ? _b : [], (tr, rowIndex) => {
    var _a2, _b2, _c;
    return `<tr class="${[
      "phr-1h5exwf",
      ((_a2 = node.table.headerRows) != null ? _a2 : -1) === rowIndex + 1 && rowIndex < ((_c = (_b2 = node.table) == null ? void 0 : _b2.body.length) != null ? _c : 0) - 1 ? "phr-header" : ""
    ].join(" ").trim()}">${each(tr, (td, columnIndex) => {
      return `${shouldRenderCell(td, rowIndex, columnIndex, coveredCells) ? `<td${add_attribute("colspan", td.colSpan, 0)}${add_attribute("rowspan", td.rowSpan, 0)}${add_attribute("style", getTableCellStyleString(td, node, rowIndex, columnIndex), 0)} class="phr-1h5exwf">${isActualTableCell(td) ? `${validate_component(ContentRenderer, "ContentRenderer").$$render($$result, { node: td }, {}, {})}` : ``} </td>` : ``}`;
    })} </tr>`;
  })} </table>`;
});
function isListNode(node) {
  return typeof node === "object" && !Array.isArray(node) && node && ("ul" in node || "ol" in node);
}
function getListItemsToRender(list) {
  if (!Array.isArray(list)) return [];
  return list.map((entry, index) => {
    const next = isListNode(list[index + 1]) ? list[index + 1] : null;
    return index === 0 || !isListNode(entry) ? [entry, next, index] : null;
  }).filter(Boolean);
}
function getUnorderedListStyleString(node) {
  var _a;
  const style = {
    "list-style-type": (_a = node.type) != null ? _a : "disc"
  };
  if (node.markerColor) style["--marker-color"] = node.markerColor;
  return getStyleString(style);
}
function getUnorderedListEntryStyleString(entry) {
  if (!entry.listType) return void 0;
  return getStyleString({
    "list-style-type": entry.listType
  });
}
const romanChars = {
  1: "I",
  5: "V",
  10: "X",
  50: "L",
  100: "C",
  500: "D",
  1e3: "M"
};
function getRomanChars(num, start = 1e3) {
  var _a, _b, _c, _d, _e, _f;
  let chars = "";
  let current = num;
  while (current >= start) {
    chars += (_a = romanChars[start]) != null ? _a : "";
    current -= start;
  }
  if (current < 1) return chars;
  if (current >= start * 0.9) {
    chars += (_b = romanChars[start / 10]) != null ? _b : "";
    chars += (_c = romanChars[start]) != null ? _c : "";
    current -= start * 0.9;
  }
  if (current < 1) return chars;
  if (current >= start / 2) {
    chars += (_d = romanChars[start / 2]) != null ? _d : "";
    current -= start / 2;
  }
  if (current >= start * 0.4) {
    chars += (_e = romanChars[start / 10]) != null ? _e : "";
    chars += (_f = romanChars[start / 2]) != null ? _f : "";
    current -= start * 0.4;
  }
  if (current < 1 || start < 10) return chars;
  return chars + getRomanChars(current, start / 10);
}
function getMaxCharacters(node) {
  var _a;
  if (!Array.isArray(node.ol)) return 1;
  let largestNumber = ((_a = node.start) != null ? _a : 1) + node.ol.length;
  const counters = node.ol.filter((it) => it.counter).map((it) => it.counter);
  if (counters.length) {
    largestNumber = Math.max(largestNumber, ...counters);
  }
  switch (node.type) {
    case "upper-alpha":
    case "lower-alpha":
      return Math.ceil(Math.log(largestNumber) / Math.log(26));
    case "upper-roman":
    case "lower-roman":
      return getRomanChars(largestNumber).length;
    case "none":
      return 1;
    case "decimal":
    default:
      return Math.ceil(Math.log10(largestNumber));
  }
}
function getOrderedListStyleString(node) {
  var _a, _b, _c, _d;
  let characters = getMaxCharacters(node);
  const separator1 = node.separator && Array.isArray(node.separator) ? node.separator[0] : "";
  let separator2 = ".";
  if (node.separator) {
    separator2 = Array.isArray(node.separator) ? (_a = node.separator[1]) != null ? _a : "" : node.separator;
  }
  characters += separator1.length + separator2.length;
  const style = {
    "padding-left": 0.25 + characters * 0.6 + "em",
    "--separator1": JSON.stringify(separator1),
    "--separator2": JSON.stringify(separator2 + " ")
  };
  const listType = (_b = node.type) != null ? _b : "decimal";
  style["list-style-type"] = listType;
  style["--list-type"] = listType;
  if (listType === "none") {
    style["--separator1"] = "''";
    style["--separator2"] = "''";
  }
  if (node.markerColor) style["--marker-color"] = node.markerColor;
  const startPosition = node.reversed ? ((_c = node.start) != null ? _c : node.ol.length) + 1 : ((_d = node.start) != null ? _d : 1) - 1;
  if (startPosition !== 0) style["counter-reset"] = `item ${startPosition}`;
  return getStyleString(style);
}
function getOrderedListEntryStyleString(entry) {
  if (entry.counter === void 0 && !entry.listType) return void 0;
  const style = {};
  if (entry.counter !== void 0) {
    style["counter-set"] = "custom " + entry.counter;
  }
  if (entry.listType) {
    style["list-style-type"] = entry.listType;
    style["--list-type"] = entry.listType;
    if (entry.listType === "none") {
      style["--separator1"] = "''";
      style["--separator2"] = "''";
    }
  }
  return getStyleString(style);
}
const css$c = {
  code: "ul.phr-fseb2g{list-style-type:disc;margin:0;padding-left:1em}li.phr-fseb2g::marker{color:var(--marker-color)}",
  map: `{"version":3,"file":"ContentUnorderedListRenderer.svelte","sources":["ContentUnorderedListRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">import { getListItemsToRender } from '../logic/list';\\nimport { getUnorderedListEntryStyleString, getUnorderedListStyleString, } from '../styling/list';\\nimport ContentRenderer from './ContentRenderer.svelte';\\nexport let node;\\n$: entriesToRender = getListItemsToRender(node.ul);\\n<\/script>\\n\\n<ul style={getUnorderedListStyleString(node)}>\\n  {#each entriesToRender as [entry, nextEntry]}\\n    <li style={getUnorderedListEntryStyleString(entry)}>\\n      <ContentRenderer node={entry} />\\n      {#if nextEntry}\\n        <ContentRenderer node={nextEntry} />\\n      {/if}\\n    </li>\\n  {/each}\\n</ul>\\n\\n<style>\\n  ul {\\n    list-style-type: disc;\\n    margin: 0;\\n    padding-left: 1em;\\n  }\\n\\n  li::marker {\\n    color: var(--marker-color);\\n  }\\n</style>\\n"],"names":[],"mappings":"AAmBE,aAAG,CACD,eAAe,CAAE,IAAI,CACrB,MAAM,CAAE,CAAC,CACT,YAAY,CAAE,GAChB,CAEA,aAAE,QAAS,CACT,KAAK,CAAE,IAAI,cAAc,CAC3B"}`
};
const ContentUnorderedListRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let entriesToRender;
  let { node } = $$props;
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  $$result.css.add(css$c);
  entriesToRender = getListItemsToRender(node.ul);
  return `<ul${add_attribute("style", getUnorderedListStyleString(node), 0)} class="phr-fseb2g">${each(entriesToRender, ([entry, nextEntry]) => {
    return `<li${add_attribute("style", getUnorderedListEntryStyleString(entry), 0)} class="phr-fseb2g">${validate_component(ContentRenderer, "ContentRenderer").$$render($$result, { node: entry }, {}, {})} ${nextEntry ? `${validate_component(ContentRenderer, "ContentRenderer").$$render($$result, { node: nextEntry }, {}, {})}` : ``} </li>`;
  })} </ul>`;
});
const css$b = {
  code: "ol.phr-9tkcz0.phr-9tkcz0{margin:0;counter-reset:item}li.phr-9tkcz0.phr-9tkcz0{counter-increment:item}ol.phr-reversed.phr-9tkcz0 li.phr-9tkcz0{counter-increment:item -1}li.phr-9tkcz0.phr-9tkcz0::marker{color:var(--marker-color);content:var(--separator1) counter(item, var(--list-type, decimal))\n      var(--separator2)}.phr-customCounter.phr-9tkcz0.phr-9tkcz0::marker{content:var(--separator1) counter(custom, var(--list-type, decimal))\n      var(--separator2)}",
  map: `{"version":3,"file":"ContentOrderedListRenderer.svelte","sources":["ContentOrderedListRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">import { getListItemsToRender } from '../logic/list';\\nimport { getOrderedListEntryStyleString, getOrderedListStyleString, } from '../styling/list';\\nimport ContentRenderer from './ContentRenderer.svelte';\\nexport let node;\\n$: entriesToRender = getListItemsToRender(node.ol);\\n<\/script>\\n\\n<ol\\n  start={node.start}\\n  class:phr-reversed={node.reversed}\\n  style={getOrderedListStyleString(node)}\\n>\\n  {#each entriesToRender as [entry, nextEntry]}\\n    <li\\n      class:phr-customCounter={entry.counter !== undefined}\\n      style={getOrderedListEntryStyleString(entry)}\\n    >\\n      <ContentRenderer node={entry} />\\n      {#if nextEntry}\\n        <ContentRenderer node={nextEntry} />\\n      {/if}\\n    </li>\\n  {/each}\\n</ol>\\n\\n<style>\\n  ol {\\n    margin: 0;\\n    counter-reset: item;\\n  }\\n\\n  li {\\n    counter-increment: item;\\n  }\\n\\n  ol.phr-reversed li {\\n    counter-increment: item -1;\\n  }\\n\\n  li::marker {\\n    color: var(--marker-color);\\n    content: var(--separator1) counter(item, var(--list-type, decimal))\\n      var(--separator2);\\n  }\\n\\n  .phr-customCounter::marker {\\n    content: var(--separator1) counter(custom, var(--list-type, decimal))\\n      var(--separator2);\\n  }\\n</style>\\n"],"names":[],"mappings":"AA0BE,wBAAG,CACD,MAAM,CAAE,CAAC,CACT,aAAa,CAAE,IACjB,CAEA,wBAAG,CACD,iBAAiB,CAAE,IACrB,CAEA,EAAE,wBAAa,CAAC,aAAG,CACjB,iBAAiB,CAAE,IAAI,CAAC,EAC1B,CAEA,wBAAE,QAAS,CACT,KAAK,CAAE,IAAI,cAAc,CAAC,CAC1B,OAAO,CAAE,IAAI,YAAY,CAAC,CAAC,QAAQ,IAAI,CAAC,CAAC,IAAI,WAAW,CAAC,QAAQ,CAAC,CAAC;AACvE,MAAM,IAAI,YAAY,CACpB,CAEA,wCAAkB,QAAS,CACzB,OAAO,CAAE,IAAI,YAAY,CAAC,CAAC,QAAQ,MAAM,CAAC,CAAC,IAAI,WAAW,CAAC,QAAQ,CAAC,CAAC;AACzE,MAAM,IAAI,YAAY,CACpB"}`
};
const ContentOrderedListRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let entriesToRender;
  let { node } = $$props;
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  $$result.css.add(css$b);
  entriesToRender = getListItemsToRender(node.ol);
  return `<ol${add_attribute("start", node.start, 0)}${add_attribute("style", getOrderedListStyleString(node), 0)} class="${["phr-9tkcz0", node.reversed ? "phr-reversed" : ""].join(" ").trim()}">${each(entriesToRender, ([entry, nextEntry]) => {
    return `<li${add_attribute("style", getOrderedListEntryStyleString(entry), 0)} class="${["phr-9tkcz0", entry.counter !== void 0 ? "phr-customCounter" : ""].join(" ").trim()}">${validate_component(ContentRenderer, "ContentRenderer").$$render($$result, { node: entry }, {}, {})} ${nextEntry ? `${validate_component(ContentRenderer, "ContentRenderer").$$render($$result, { node: nextEntry }, {}, {})}` : ``} </li>`;
  })} </ol>`;
});
function getImageStyleString(node) {
  const style = {};
  if (node.width) style.width = node.width + "pt";
  if (node.height) style.height = node.height + "pt";
  if (node.fit && Array.isArray(node.fit)) {
    const [maxWidth, maxHeight] = node.fit;
    style["width"] = maxWidth + "pt";
    style["max-height"] = maxHeight + "pt";
    style["object-fit"] = "contain";
    style["object-position"] = "left top";
  } else if ("cover" in node && node.cover) {
    const { width, height, align, valign } = node.cover;
    if (width) style["width"] = width + "pt";
    if (height) style["height"] = height + "pt";
    style["object-fit"] = "cover";
    style["object-position"] = `${align != null ? align : "center"} ${valign != null ? valign : "center"}`;
  }
  return getStyleString(style);
}
const css$a = {
  code: "img.phr-nj0wk{display:block}",
  map: `{"version":3,"file":"ContentImageRenderer.svelte","sources":["ContentImageRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">var _a, _b;\\nimport { getDocument } from '../context';\\nimport { getImageStyleString } from '../styling/image';\\nexport let node;\\nconst document = getDocument();\\n$: image = (_a = $document.images) === null || _a === void 0 ? void 0 : _a[node.image];\\n$: src = (_b = (typeof image === 'object' ? image.url : image)) !== null && _b !== void 0 ? _b : node.image;\\n<\/script>\\n\\n<img {src} alt=\\"\\" style={getImageStyleString(node)} />\\n\\n<style>\\n  img {\\n    display: block;\\n  }\\n</style>\\n"],"names":[],"mappings":"AAYE,aAAI,CACF,OAAO,CAAE,KACX"}`
};
const ContentImageRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let image;
  let src;
  let $document, $$unsubscribe_document;
  var _a, _b;
  let { node } = $$props;
  const document = getDocument();
  $$unsubscribe_document = subscribe(document, (value) => $document = value);
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  $$result.css.add(css$a);
  image = (_a = $document.images) === null || _a === void 0 ? void 0 : _a[node.image];
  src = (_b = typeof image === "object" ? image.url : image) !== null && _b !== void 0 ? _b : node.image;
  $$unsubscribe_document();
  return `<img${add_attribute("src", src, 0)} alt=""${add_attribute("style", getImageStyleString(node), 0)} class="phr-nj0wk">`;
});
const css$9 = {
  code: "img.phr-nj0wk{display:block}",
  map: `{"version":3,"file":"ContentSvgRenderer.svelte","sources":["ContentSvgRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">import { getImageStyleString } from '../styling/image';\\nexport let node;\\n$: src = 'data:image/svg+xml,' + encodeURIComponent(node.svg);\\n<\/script>\\n\\n<img {src} alt=\\"\\" style={getImageStyleString(node)} />\\n\\n<style>\\n  img {\\n    display: block;\\n  }\\n</style>\\n"],"names":[],"mappings":"AAQE,aAAI,CACF,OAAO,CAAE,KACX"}`
};
const ContentSvgRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let src;
  let { node } = $$props;
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  $$result.css.add(css$9);
  src = "data:image/svg+xml," + encodeURIComponent(node.svg);
  return `<img${add_attribute("src", src, 0)} alt=""${add_attribute("style", getImageStyleString(node), 0)} class="phr-nj0wk">`;
});
const css$8 = {
  code: "a.phr-1wy9hju{color:inherit;text-decoration:none}",
  map: `{"version":3,"file":"ContentLinkRenderer.svelte","sources":["ContentLinkRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">import ContentRenderer from './ContentRenderer.svelte';\\n// cannot use ContentLink as it is only a sub-type that ContentRenderer won't accept\\nexport let node;\\n<\/script>\\n\\n<a\\n  href={node.link ?? '#' + node.linkToDestination}\\n  target={node.link ? '_blank' : undefined}\\n>\\n  <ContentRenderer {node} inline inLink />\\n</a>\\n\\n<style>\\n  a {\\n    color: inherit;\\n    text-decoration: none;\\n  }\\n</style>\\n"],"names":[],"mappings":"AAaE,aAAE,CACA,KAAK,CAAE,OAAO,CACd,eAAe,CAAE,IACnB"}`
};
const ContentLinkRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  var _a;
  let { node } = $$props;
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  $$result.css.add(css$8);
  return `<a${add_attribute("href", (_a = node.link) != null ? _a : "#" + node.linkToDestination, 0)}${add_attribute("target", node.link ? "_blank" : void 0, 0)} class="phr-1wy9hju">${validate_component(ContentRenderer, "ContentRenderer").$$render($$result, { node, inline: true, inLink: true }, {}, {})} </a>`;
});
function buildQrCode(node) {
  return __async(this, null, function* () {
    if (!QRCode) return null;
    return new Promise((resolve) => {
      QRCode.toString(
        node.mode ? [
          node.mode === "octet" ? { data: new TextEncoder().encode(node.qr), mode: "byte" } : { data: node.qr, mode: node.mode }
        ] : node.qr,
        {
          version: node.version,
          color: {
            dark: colorToHex(node.foreground),
            light: colorToHex(node.background)
          },
          errorCorrectionLevel: node.eccLevel,
          maskPattern: node.mask,
          margin: 0
        },
        (err, result) => {
          resolve(err ? null : "data:image/svg+xml," + encodeURIComponent(result));
        }
      );
    });
  });
}
function getQrStyleString(node, src) {
  var _a;
  const style = {};
  const defaultZoom = 5;
  const naturalWidth = parseInt(decodeURIComponent(src).match(/viewBox="0 0 (\d+) (\d+)"/i)[1]) * defaultZoom;
  const naturalPadding = ((_a = node.padding) != null ? _a : 0) * defaultZoom;
  if (node.fit) {
    const padding = naturalPadding * (node.fit / naturalWidth);
    Object.assign(style, {
      // pdfmake seems to shrink the QR code by certain fixed factors and is often actually smaller
      width: node.fit + "pt",
      height: node.fit + "pt",
      padding: padding + "pt"
    });
  } else {
    Object.assign(style, {
      width: naturalWidth + "pt",
      height: naturalWidth + "pt",
      padding: naturalPadding + "pt"
    });
  }
  return getStyleString(style);
}
const css$7 = {
  code: "img.phr-188fgs8{display:inline-block}",
  map: `{"version":3,"file":"ContentQrRenderer.svelte","sources":["ContentQrRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">import { buildQrCode } from '../logic/qr';\\nimport { getQrStyleString } from '../styling/qr';\\nexport let node;\\n$: qrCode = buildQrCode(node);\\n<\/script>\\n\\n{#await qrCode then src}\\n  {#if src}\\n    <img {src} alt=\\"\\" style={getQrStyleString(node, src)} />\\n  {/if}\\n{/await}\\n\\n<style>\\n  img {\\n    display: inline-block;\\n  }\\n</style>\\n"],"names":[],"mappings":"AAaE,eAAI,CACF,OAAO,CAAE,YACX"}`
};
const ContentQrRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let qrCode;
  let { node } = $$props;
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  $$result.css.add(css$7);
  qrCode = buildQrCode(node);
  return `${function(__value) {
    if (is_promise(__value)) {
      __value.then(null, noop);
      return ``;
    }
    return function(src) {
      return ` ${src ? `<img${add_attribute("src", src, 0)} alt=""${add_attribute("style", getQrStyleString(node, src), 0)} class="phr-188fgs8">` : ``} `;
    }(__value);
  }(qrCode)}`;
});
function getCanvasProperties(node) {
  let width = 1;
  let height = 1;
  if (Array.isArray(node.canvas)) {
    node.canvas.forEach((element) => {
      var _a;
      if ("w" in element) {
        const w = element.x + element.w;
        if (w > width) width = w;
        const h = element.y + element.h;
        if (h > height) height = h;
      } else if ("r1" in element) {
        const w = element.x + element.r1;
        if (w > width) width = w;
        const h = element.y + ((_a = element.r2) != null ? _a : element.r1);
        if (h > height) height = h;
      } else if ("x1" in element) {
        const w = Math.max(element.x1, element.x2);
        if (w > width) width = w;
        const h = Math.max(element.y1, element.y2);
        if (h > height) height = h;
      } else if ("points" in element && Array.isArray(element.points)) {
        element.points.forEach((point) => {
          if (!point) return;
          if (point.x > width) width = point.x;
          if (point.y > height) height = point.y;
        });
      }
    });
  }
  return {
    width: width + "pt",
    height: height + "pt"
  };
}
function getCanvasFilledElementProperties(element, index) {
  const properties = {
    fill: "none"
  };
  if (element.linearGradient) {
    properties.fill = `url('#gradient${index}')`;
  } else if (element.color) {
    const color = opacityColor(element.color, element.fillOpacity);
    if (color) properties.fill = color;
  }
  return properties;
}
function getCanvasLineElementProperties(element) {
  var _a, _b;
  if (!element.lineColor && ("color" in element || "linearGradient" in element)) {
    return {};
  }
  const properties = {
    stroke: (_a = element.lineColor) != null ? _a : "#000",
    "stroke-width": ((_b = element.lineWidth) != null ? _b : 1) + "pt"
  };
  if (element.strokeOpacity !== void 0) {
    properties["stroke-opacity"] = String(element.strokeOpacity);
  }
  if (element.lineJoin) {
    properties["stroke-linejoin"] = element.lineJoin;
  }
  if (element.dash && typeof element.dash === "object") {
    const { space, length } = element.dash;
    properties["stroke-dasharray"] = `${length}pt,${space != null ? space : length}pt`;
  }
  return properties;
}
function getCanvasRectProperties(rect, index) {
  const properties = __spreadProps(__spreadValues(__spreadValues({}, getCanvasFilledElementProperties(rect, index)), getCanvasLineElementProperties(rect)), {
    x: rect.x + "pt",
    y: rect.y + "pt",
    width: Math.max(rect.w, rect.h ? 1 : 0) + "pt",
    height: Math.max(rect.h, rect.w ? 1 : 0) + "pt"
  });
  if (rect.r) {
    properties.rx = rect.r + "pt";
    properties.ry = rect.r + "pt";
  }
  return properties;
}
function getCanvasEllipseProperties(ellipse, index) {
  var _a;
  const properties = __spreadProps(__spreadValues(__spreadValues({}, getCanvasFilledElementProperties(ellipse, index)), getCanvasLineElementProperties(ellipse)), {
    cx: ellipse.x + "pt",
    cy: ellipse.y + "pt",
    rx: ellipse.r1 + "pt",
    ry: ((_a = ellipse.r2) != null ? _a : ellipse.r1) + "pt"
  });
  return properties;
}
function getCanvasLineProperties(line) {
  const properties = __spreadProps(__spreadValues({}, getCanvasLineElementProperties(line)), {
    x1: line.x1 + "pt",
    x2: line.x2 + "pt",
    y1: line.y1 + "pt",
    y2: line.y2 + "pt"
  });
  if (line.lineCap) {
    properties["stroke-linecap"] = line.lineCap;
  }
  return properties;
}
function getCanvasPolylineProperties(line, index) {
  if (!Array.isArray(line.points)) return {};
  const points = line.closePath ? [...line.points, line.points[0]] : line.points;
  const properties = __spreadProps(__spreadValues(__spreadValues({}, getCanvasFilledElementProperties(line, index)), getCanvasLineElementProperties(line)), {
    points: points.filter((point) => typeof point === "object" && !!point).map(({ x, y }) => `${x * 4 / 3},${y * 4 / 3}`).join(" ")
  });
  if (line.lineCap) {
    properties["stroke-linecap"] = line.lineCap;
  }
  return properties;
}
const css$6 = {
  code: "svg.phr-fftrry{display:block;overflow:visible}",
  map: `{"version":3,"file":"ContentCanvasRenderer.svelte","sources":["ContentCanvasRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">import { getCanvasEllipseProperties, getCanvasLineProperties, getCanvasPolylineProperties, getCanvasProperties, getCanvasRectProperties, } from '../styling/canvas';\\nexport let node;\\n<\/script>\\n\\n<svg {...getCanvasProperties(node)}>\\n  <defs>\\n    {#each node.canvas as element, elementIndex}\\n      {#if 'linearGradient' in element && element.linearGradient?.length}\\n        <linearGradient id=\\"gradient{elementIndex}\\">\\n          {#each element.linearGradient as stopColor, stopIndex}\\n            <stop\\n              offset=\\"{(stopIndex /\\n                ((element.linearGradient?.length ?? 1) - 1)) *\\n                100}%\\"\\n              stop-color={stopColor}\\n              stop-opacity={element.fillOpacity}\\n            />\\n          {/each}\\n        </linearGradient>\\n      {/if}\\n    {/each}\\n  </defs>\\n  {#each node.canvas as element, index}\\n    {#if element.type === 'rect'}\\n      <rect {...getCanvasRectProperties(element, index)} />\\n    {:else if element.type === 'ellipse'}\\n      <ellipse {...getCanvasEllipseProperties(element, index)} />\\n    {:else if element.type === 'line'}\\n      <line {...getCanvasLineProperties(element)} />\\n    {:else if element.type === 'polyline'}\\n      <polyline {...getCanvasPolylineProperties(element, index)} />\\n    {/if}\\n  {/each}\\n</svg>\\n\\n<style>\\n  svg {\\n    display: block;\\n    overflow: visible;\\n  }\\n</style>\\n"],"names":[],"mappings":"AAoCE,cAAI,CACF,OAAO,CAAE,KAAK,CACd,QAAQ,CAAE,OACZ"}`
};
const ContentCanvasRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let { node } = $$props;
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  $$result.css.add(css$6);
  return `<svg${spread([escape_object(getCanvasProperties(node))], { classes: "phr-fftrry" })}><defs>${each(node.canvas, (element, elementIndex) => {
    var _a;
    return `${"linearGradient" in element && ((_a = element.linearGradient) == null ? void 0 : _a.length) ? `<linearGradient id="${"gradient" + escape(elementIndex, true)}">${each(element.linearGradient, (stopColor, stopIndex) => {
      var _a2, _b;
      return `<stop offset="${escape(stopIndex / (((_b = (_a2 = element.linearGradient) == null ? void 0 : _a2.length) != null ? _b : 1) - 1) * 100, true) + "%"}"${add_attribute("stop-color", stopColor, 0)}${add_attribute("stop-opacity", element.fillOpacity, 0)}></stop>`;
    })}</linearGradient>` : ``}`;
  })}</defs>${each(node.canvas, (element, index) => {
    return `${element.type === "rect" ? `<rect${spread([escape_object(getCanvasRectProperties(element, index))], {})}></rect>` : `${element.type === "ellipse" ? `<ellipse${spread([escape_object(getCanvasEllipseProperties(element, index))], {})}></ellipse>` : `${element.type === "line" ? `<line${spread([escape_object(getCanvasLineProperties(element))], {})}></line>` : `${element.type === "polyline" ? `<polyline${spread([escape_object(getCanvasPolylineProperties(element, index))], {})}></polyline>` : ``}`}`}`}`;
  })}</svg>`;
});
function toArray(value) {
  return Array.isArray(value) ? value : [value];
}
function getTocItemNodes(tocNode, content) {
  return flattenNodes(content).filter(
    (node) => {
      var _a;
      return typeof node === "object" && node && "tocItem" in node && toArray(node.tocItem).includes((_a = tocNode.toc.id) != null ? _a : true);
    }
  );
}
function getTocTarget(node, allNodes) {
  const index = allNodes.indexOf(node);
  if (index === -1) return void 0;
  return `node${index + 1}`;
}
function getMarginString(margins, defaultMargin = 0) {
  if (!margins) return defaultMargin + "pt";
  if (Array.isArray(margins)) {
    if (margins.length >= 4) {
      const [left, top, right, bottom] = margins;
      return [top, right, bottom, left].map((it) => (it != null ? it : 0) + "pt").join(" ");
    } else {
      const [horizontal, vertical] = margins;
      return [vertical, horizontal].map((it) => (it != null ? it : 0) + "pt").join(" ");
    }
  }
  return margins + "pt";
}
function getMarginStringFromStyle(style) {
  var _a, _b, _c, _d;
  if (style.margin !== void 0) {
    return getMarginString(style.margin);
  }
  const margins = [
    (_a = style.marginLeft) != null ? _a : 0,
    (_b = style.marginTop) != null ? _b : 0,
    (_c = style.marginRight) != null ? _c : 0,
    (_d = style.marginBottom) != null ? _d : 0
  ];
  if (margins.some((it) => it !== 0)) {
    return getMarginString(margins);
  }
  return void 0;
}
function getStyleDictionary(style, isNode = false) {
  const obj = {};
  if (!style || typeof style !== "object") return obj;
  if (style.font)
    obj["font-family"] = style.font + ", Roboto, Helvetica, sans-serif";
  if (style.fontSize) {
    obj["font-size"] = style.fontSize + "pt";
    obj["--font-size"] = style.fontSize + "pt";
  }
  if (style.lineHeight) obj["line-height"] = String(style.lineHeight);
  if (style.bold !== void 0)
    obj["font-weight"] = style.bold ? "bold" : "normal";
  if (style.italics !== void 0)
    obj["font-style"] = style.italics ? "italic" : "normal";
  if (style.alignment) {
    obj["text-align"] = style.alignment;
    obj.display = "block";
  }
  if (style.color) obj.color = style.color;
  if (style.background && !Array.isArray(style.background)) {
    obj["--background"] = style.background;
  }
  const marginStyle = getMarginStringFromStyle(style);
  if (marginStyle !== void 0) {
    obj.display = "block";
    if (!isNode || style.margin !== void 0) {
      obj.padding = marginStyle;
    } else {
      if (style.marginLeft !== void 0)
        obj["padding-left"] = style.marginLeft + "pt";
      if (style.marginTop !== void 0)
        obj["padding-top"] = style.marginTop + "pt";
      if (style.marginRight !== void 0)
        obj["padding-right"] = style.marginRight + "pt";
      if (style.marginBottom !== void 0)
        obj["padding-bottom"] = style.marginBottom + "pt";
    }
  }
  if (style.decoration) {
    obj["text-decoration"] = (Array.isArray(style.decoration) ? style.decoration : [style.decoration]).map((it) => it === "lineThrough" ? "line-through" : it).join(" ");
  }
  if (style.decorationColor) {
    obj["text-decoration-color"] = style.decorationColor;
  }
  if (style.decorationStyle) {
    obj["text-decoration-style"] = style.decorationStyle;
  }
  if (style.opacity) obj.opacity = String(style.opacity);
  if (style.characterSpacing)
    obj["letter-spacing"] = style.characterSpacing + "pt";
  if (style.leadingIndent) {
    obj["text-indent"] = style.leadingIndent + "pt";
    obj.display = "block";
  }
  if (style.sub || style.sup) {
    obj["vertical-align"] = style.sub ? "sub" : "top";
    if (!style.fontSize) {
      obj["font-size"] = "calc(var(--font-size) * 0.58)";
    }
  }
  if (style.fillColor) {
    const fillColorRgb = colorToRgb(style.fillColor);
    if (fillColorRgb) {
      obj["--fill-color"] = fillColorRgb.join(", ");
      obj["--fill-opacity"] = "1";
    }
  }
  if (style.fillOpacity !== void 0)
    obj["--fill-opacity"] = String(style.fillOpacity);
  if (style.noWrap) {
    obj["white-space"] = "nowrap";
    obj["--white-space"] = "nowrap";
  }
  if (style.columnGap !== void 0) {
    obj["--column-gap"] = String(Number(style.columnGap) / 2) + "pt";
  }
  return obj;
}
function getTocItemStyleString(node, tocNode, document) {
  var _a, _b;
  const textStyle = (_a = node.tocStyle) != null ? _a : tocNode.toc.textStyle;
  const margin = (_b = node.tocMargin) != null ? _b : tocNode.toc.textMargin;
  const style = {
    display: "block",
    padding: getMarginString(margin)
  };
  const applyBaseStyle = (nameOrStyle) => {
    var _a2;
    if (typeof nameOrStyle === "object") {
      Object.assign(style, nameOrStyle);
      return;
    }
    const baseStyle = (_a2 = document.styles) == null ? void 0 : _a2[nameOrStyle];
    if (baseStyle) {
      Object.assign(style, getStyleDictionary(baseStyle));
    }
  };
  if (textStyle) {
    if (typeof textStyle === "string") {
      applyBaseStyle(textStyle);
    } else if (Array.isArray(textStyle)) {
      textStyle.forEach(applyBaseStyle);
    } else {
      Object.assign(style, getStyleDictionary(textStyle));
    }
  }
  return getStyleString(style);
}
const css$5 = {
  code: ".phr-title.phr-1u0ml00{margin-bottom:12pt}.phr-tocItem.phr-1u0ml00{display:block;margin:6pt 0;text-decoration:unset;color:unset}",
  map: `{"version":3,"file":"ContentTocRenderer.svelte","sources":["ContentTocRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">import { getDocument, getDocumentNodes } from '../context';\\nimport { getTocItemNodes, getTocTarget } from '../logic/toc';\\nimport { getTocItemStyleString } from '../styling/toc';\\nimport ContentRenderer from './ContentRenderer.svelte';\\nexport let node;\\nconst document = getDocument();\\nconst nodes = getDocumentNodes();\\n<\/script>\\n\\n<div>\\n  {#if node.toc.title}\\n    <div class=\\"phr-title\\">\\n      <ContentRenderer node={node.toc.title} />\\n    </div>\\n  {/if}\\n  {#each getTocItemNodes(node, $document.content) as tocItem}\\n    <a class=\\"phr-tocItem\\" href=\\"#{getTocTarget(tocItem, $nodes)}\\">\\n      <ContentRenderer\\n        node={tocItem}\\n        inToc\\n        overrideStyle={getTocItemStyleString(tocItem, node, $document)}\\n      />\\n    </a>\\n  {/each}\\n</div>\\n\\n<style>\\n  .phr-title {\\n    margin-bottom: 12pt;\\n  }\\n  .phr-tocItem {\\n    display: block;\\n    margin: 6pt 0;\\n    text-decoration: unset;\\n    color: unset;\\n  }\\n</style>\\n"],"names":[],"mappings":"AA2BE,sBAAW,CACT,aAAa,CAAE,IACjB,CACA,wBAAa,CACX,OAAO,CAAE,KAAK,CACd,MAAM,CAAE,GAAG,CAAC,CAAC,CACb,eAAe,CAAE,KAAK,CACtB,KAAK,CAAE,KACT"}`
};
const ContentTocRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let $document, $$unsubscribe_document;
  let $nodes, $$unsubscribe_nodes;
  let { node } = $$props;
  const document = getDocument();
  $$unsubscribe_document = subscribe(document, (value) => $document = value);
  const nodes = getDocumentNodes();
  $$unsubscribe_nodes = subscribe(nodes, (value) => $nodes = value);
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  $$result.css.add(css$5);
  $$unsubscribe_document();
  $$unsubscribe_nodes();
  return `<div>${node.toc.title ? `<div class="phr-title phr-1u0ml00">${validate_component(ContentRenderer, "ContentRenderer").$$render($$result, { node: node.toc.title }, {}, {})}</div>` : ``} ${each(getTocItemNodes(node, $document.content), (tocItem) => {
    return `<a class="phr-tocItem phr-1u0ml00" href="${"#" + escape(getTocTarget(tocItem, $nodes), true)}">${validate_component(ContentRenderer, "ContentRenderer").$$render(
      $$result,
      {
        node: tocItem,
        inToc: true,
        overrideStyle: getTocItemStyleString(tocItem, node, $document)
      },
      {},
      {}
    )} </a>`;
  })} </div>`;
});
function getNodeText(node) {
  if (!node) return "";
  if (typeof node === "string" || typeof node === "number") return String(node);
  if (Array.isArray(node)) return node.map(getNodeText).join("");
  if ("text" in node && node.text) return getNodeText(node.text);
  return "";
}
function getReferencedNode(reference, nodes) {
  return nodes.find(
    (node) => typeof node === "object" && node && "id" in node && node.id === reference
  );
}
function getReferenceText(reference, nodes) {
  const node = getReferencedNode(reference, nodes);
  if (!node) return "";
  return getNodeText(node);
}
const css$4 = {
  code: "a.phr-1wy9hju{color:inherit;text-decoration:none}",
  map: `{"version":3,"file":"ContentPageReferenceRenderer.svelte","sources":["ContentPageReferenceRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">import { getDocumentNodes } from '../context';\\nimport { getReferenceText } from '../logic/reference';\\nexport let node;\\nconst nodes = getDocumentNodes();\\n<\/script>\\n\\n<a\\n  href=\\"#{node.pageReference}\\"\\n  title={getReferenceText(node.pageReference, $nodes)}>X</a\\n>\\n\\n<style>\\n  a {\\n    color: inherit;\\n    text-decoration: none;\\n  }\\n</style>\\n"],"names":[],"mappings":"AAYE,aAAE,CACA,KAAK,CAAE,OAAO,CACd,eAAe,CAAE,IACnB"}`
};
const ContentPageReferenceRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let $nodes, $$unsubscribe_nodes;
  let { node } = $$props;
  const nodes = getDocumentNodes();
  $$unsubscribe_nodes = subscribe(nodes, (value) => $nodes = value);
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  $$result.css.add(css$4);
  $$unsubscribe_nodes();
  return `<a href="${"#" + escape(node.pageReference, true)}"${add_attribute("title", getReferenceText(node.pageReference, $nodes), 0)} class="phr-1wy9hju">X</a>`;
});
const css$3 = {
  code: "a.phr-7q9px8{color:inherit;text-decoration:none;font-size:0}a.phr-7q9px8>*{font-size:var(--font-size)}",
  map: `{"version":3,"file":"ContentTextReferenceRenderer.svelte","sources":["ContentTextReferenceRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">import { getDocumentNodes } from '../context';\\nimport { getReferencedNode, getReferenceText } from '../logic/reference';\\nimport ContentRenderer from './ContentRenderer.svelte';\\nexport let node;\\nconst nodes = getDocumentNodes();\\n$: referencedNode = getReferencedNode(node.textReference, $nodes);\\n<\/script>\\n\\n<a href=\\"#{node.textReference}\\">\\n  <!-- we cannot just render the whole refernced node, as its own styles are not applied -->\\n  {#if referencedNode && typeof referencedNode === 'object' && 'text' in referencedNode}\\n    <ContentRenderer node={referencedNode.text} inline />\\n  {:else}\\n    <span>{getReferenceText(node.textReference, $nodes)}</span>\\n  {/if}\\n</a>\\n\\n<style>\\n  a {\\n    color: inherit;\\n    text-decoration: none;\\n    /* Prevent superfluous whitespace */\\n    font-size: 0;\\n  }\\n\\n  a > :global(*) {\\n    font-size: var(--font-size);\\n  }\\n</style>\\n"],"names":[],"mappings":"AAkBE,YAAE,CACA,KAAK,CAAE,OAAO,CACd,eAAe,CAAE,IAAI,CAErB,SAAS,CAAE,CACb,CAEA,YAAC,CAAW,CAAG,CACb,SAAS,CAAE,IAAI,WAAW,CAC5B"}`
};
const ContentTextReferenceRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let referencedNode;
  let $nodes, $$unsubscribe_nodes;
  let { node } = $$props;
  const nodes = getDocumentNodes();
  $$unsubscribe_nodes = subscribe(nodes, (value) => $nodes = value);
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  $$result.css.add(css$3);
  referencedNode = getReferencedNode(node.textReference, $nodes);
  $$unsubscribe_nodes();
  return `<a href="${"#" + escape(node.textReference, true)}" class="phr-7q9px8"> ${referencedNode && typeof referencedNode === "object" && "text" in referencedNode ? `${validate_component(ContentRenderer, "ContentRenderer").$$render($$result, { node: referencedNode.text, inline: true }, {}, {})}` : `<span>${escape(getReferenceText(node.textReference, $nodes))}</span>`} </a>`;
});
function getContentRenderer(node, inLink) {
  if (typeof node === "string" || typeof node === "number") {
    return StringRenderer;
  } else if (Array.isArray(node)) {
    return ContentArrayRenderer;
  } else if (typeof node === "object" && node && !Array.isArray(node)) {
    if (!inLink && ("link" in node || "linkToDestination" in node)) {
      return ContentLinkRenderer;
    }
    if (typeof node !== "object" || !node) return null;
    if ("columns" in node && Array.isArray(node.columns)) {
      return ContentColumnsRenderer;
    } else if ("stack" in node && Array.isArray(node.stack)) {
      return ContentStackRenderer;
    } else if ("ul" in node && Array.isArray(node.ul)) {
      return ContentUnorderedListRenderer;
    } else if ("ol" in node && Array.isArray(node.ol)) {
      return ContentOrderedListRenderer;
    } else if ("table" in node && node.table && typeof node.table === "object") {
      return ContentTableRenderer;
    } else if ("image" in node && node.image) {
      return ContentImageRenderer;
    } else if ("pageReference" in node && node.pageReference != null) {
      return ContentPageReferenceRenderer;
    } else if ("textReference" in node && node.textReference != null) {
      return ContentTextReferenceRenderer;
    } else if ("text" in node && node.text != null) {
      return ContentTextRenderer;
    } else if ("toc" in node && node.toc && typeof node.toc === "object") {
      return ContentTocRenderer;
    } else if ("svg" in node && node.svg) {
      return ContentSvgRenderer;
    } else if ("qr" in node && node.qr) {
      return ContentQrRenderer;
    } else if ("canvas" in node && Array.isArray(node.canvas)) {
      return ContentCanvasRenderer;
    }
  }
  return null;
}
function flattenNodes(node) {
  var _a;
  if (!node) return [];
  const nodes = [node];
  if (typeof node === "string" || typeof node === "number") {
    return [];
  } else if (Array.isArray(node)) {
    node.forEach((child) => nodes.push(...flattenNodes(child)));
  }
  if (typeof node !== "object" || !node) return nodes;
  const childKeys = ["columns", "stack", "ul", "ol"];
  for (const childKey of childKeys) {
    if (childKey in node && Array.isArray(node[childKey])) {
      nodes.push(...flattenNodes(node[childKey]));
      break;
    }
  }
  if ("table" in node && node.table && typeof node.table === "object") {
    (_a = node.table.body) == null ? void 0 : _a.forEach((tr) => {
      if (!Array.isArray(tr)) return;
      return tr.forEach((td) => nodes.push(...flattenNodes(td)));
    });
  } else if ("text" in node && Array.isArray(node.text)) {
    nodes.push(...flattenNodes(node.text));
  }
  return nodes;
}
const pageSizes = {
  // via https://github.com/reb2020/5no-paper-sizes
  "4A0": [4768, 6741],
  "2A0": [3370, 4768],
  A0: [2384, 3370],
  A1: [1684, 2384],
  A2: [1191, 1684],
  A3: [842, 1191],
  A4: [595, 842],
  A5: [420, 595],
  A6: [298, 420],
  A7: [210, 298],
  A8: [147, 210],
  A9: [105, 147],
  A10: [74, 105],
  B0: [2835, 4008],
  B1: [2004, 2835],
  B2: [1417, 2004],
  B3: [1001, 1417],
  B4: [709, 1001],
  B5: [499, 709],
  B6: [354, 499],
  B7: [249, 354],
  B8: [176, 249],
  B9: [125, 176],
  B10: [88, 125],
  C0: [2599, 3677],
  C1: [1837, 2599],
  C2: [1298, 1837],
  C3: [918, 1298],
  C4: [649, 918],
  C5: [459, 649],
  C6: [323, 459],
  C7: [230, 323],
  C8: [162, 230],
  C9: [113, 162],
  C10: [79, 113],
  // via https://papersizes.io/raw/ra0
  RA1: [1279, 2438],
  RA2: [1219, 1729],
  RA3: [864, 1219],
  RA4: [609, 864],
  SRA1: [1814, 2551],
  SRA2: [1275, 1814],
  SRA3: [907, 1275],
  SRA4: [637, 907],
  // via https://www.prepressure.com/library/paper-size
  // and https://www.gnu.org/software/gv/manual/html_node/Paper-Keywords-and-paper-size-in-points.html
  EXECUTIVE: [522, 756],
  FOLIO: [612, 936],
  LEGAL: [612, 1008],
  LETTER: [612, 792],
  TABLOID: [792, 1224]
};
function getPageSize(document) {
  var _a;
  let width = pageSizes.A4[0];
  let height = pageSizes.A4[1];
  if (typeof document.pageSize === "string") {
    if (pageSizes[document.pageSize]) {
      width = pageSizes[document.pageSize][0];
      height = pageSizes[document.pageSize][0];
    }
  } else if (typeof document.pageSize === "object" && document.pageSize) {
    if (document.pageSize.width) width = document.pageSize.width;
    if (document.pageSize.height && document.pageSize.height !== "auto") {
      height = document.pageSize.height;
    }
  }
  if (document.pageOrientation === "portrait" && width > height || document.pageOrientation === "landscape" && width < height) {
    [width, height] = [height, width];
  }
  return {
    width,
    height,
    orientation: (_a = document.pageOrientation) != null ? _a : "portrait"
  };
}
function getPageStyleString(document, clientWidth, mode) {
  const style = {};
  if (mode !== "fluid") {
    const { width, height } = getPageSize(document);
    style.width = width + "pt";
    style["min-height"] = height + "pt";
    if (mode !== "natural") {
      const clientWidthInPt = clientWidth * 3 / 4;
      const zoom = clientWidthInPt / width;
      if (mode === "zoomToFit" || zoom < 1) {
        style.zoom = String(clientWidthInPt / width);
      }
    }
    Object.assign(style, getStyleDictionary(document.defaultStyle));
  }
  return getStyleString(style);
}
function getPageContentStyleString(document) {
  const style = {
    padding: getMarginString(document.pageMargins, 40)
  };
  return getStyleString(style);
}
function getContentStyleDictionary(node, document, inline) {
  var _a, _b, _c, _d, _e;
  const pageSize = getPageSize(document);
  const maxWidth = pageSize.orientation === "landscape" ? pageSize.height : pageSize.width;
  const styles = {
    "max-width": maxWidth + "pt"
  };
  if (Array.isArray(node) && !inline || typeof node === "object" && node && ("columns" in node || "ul" in node || "ol" in node || "toc" in node || "stack" in node))
    styles.display = "block";
  else if (inline) styles.display = "inline";
  else if (typeof node === "object" && node && ("fontSize" in node || "lineHeight" in node))
    styles.display = "inline-block";
  if (Array.isArray(node) || typeof node === "object" && (node.stack || node.ul || node.ol || node.columns || node.qr)) {
    styles.background = "transparent";
  }
  if (typeof node !== "object" || !node || Array.isArray(node)) {
    return styles;
  }
  const applyBaseStyle = (nameOrStyle) => {
    var _a2;
    if (typeof nameOrStyle === "object") {
      Object.assign(styles, nameOrStyle);
      return;
    }
    const baseStyle = (_a2 = document.styles) == null ? void 0 : _a2[nameOrStyle];
    if (baseStyle) {
      Object.assign(styles, getStyleDictionary(baseStyle));
    }
  };
  if (node.style) {
    if (typeof node.style === "string") {
      applyBaseStyle(node.style);
    } else if (Array.isArray(node.style)) {
      node.style.forEach(applyBaseStyle);
    } else {
      Object.assign(styles, getStyleDictionary(node.style));
    }
  }
  Object.assign(styles, getStyleDictionary(node, true));
  if (inline) {
    Object.assign(styles, {
      display: "inline",
      padding: "0"
    });
  } else {
    if (node.absolutePosition && typeof node.absolutePosition === "object") {
      Object.assign(styles, {
        position: "absolute",
        left: `${(_a = node.absolutePosition.x) != null ? _a : 0}pt`,
        top: `${(_b = node.absolutePosition.y) != null ? _b : 0}pt`
      });
    }
    if (node.relativePosition && typeof node.relativePosition === "object") {
      Object.assign(styles, {
        position: "absolute",
        transform: `translate(${(_c = node.relativePosition.x) != null ? _c : 0}pt, ${(_d = node.relativePosition.y) != null ? _d : 0}pt)`
      });
    }
    for (const suffix of ["", "-left", "-top", "-right", "-bottom"]) {
      if ((_e = styles[`padding${suffix}`]) == null ? void 0 : _e.includes("-")) {
        styles[`margin${suffix}`] = styles[`padding${suffix}`];
        delete styles[`padding${suffix}`];
      }
    }
  }
  return styles;
}
function getContentStyleString(node, document, inline = false) {
  const styles = getContentStyleDictionary(
    typeof node === "string" || typeof node === "number" ? { text: node } : node,
    document,
    inline
  );
  return getStyleString(styles);
}
const css$2 = {
  code: "span.phr-n9gkpl{background:var(--background);background-clip:content-box}hr.phr-n9gkpl{margin:24pt 0}.phr-unknown.phr-n9gkpl{color:red}",
  map: `{"version":3,"file":"ContentRenderer.svelte","sources":["ContentRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">import { getDocument, getDocumentNodes } from '../context';\\nimport { getContentRenderer } from '../logic/content';\\nimport { getTocTarget } from '../logic/toc';\\nimport { getContentStyleString } from '../styling/content';\\nimport ContentLinkRenderer from './ContentLinkRenderer.svelte';\\nimport ContentTextRenderer from './ContentTextRenderer.svelte';\\nexport let node;\\nexport let inline = false;\\nexport let inToc = false;\\nexport let inLink = false;\\nexport let overrideStyle = undefined;\\nexport let first = undefined;\\nexport let last = undefined;\\nconst document = getDocument();\\nconst nodes = getDocumentNodes();\\n$: style = overrideStyle !== null && overrideStyle !== void 0 ? overrideStyle : getContentStyleString(node, $document, inline);\\n$: component = getContentRenderer(node, inLink);\\n$: id =\\n    typeof node === 'object' && node && !inToc\\n        ? 'tocItem' in node\\n            ? getTocTarget(node, $nodes)\\n            : 'id' in node\\n                ? node.id\\n                : undefined\\n        : undefined;\\n$: neverNode = node;\\n<\/script>\\n\\n{#if !inToc && typeof node === 'object' && node && 'pageBreak' in node && (node.pageBreak === 'before' || node.pageBreak === 'beforeEven' || node.pageBreak === 'beforeOdd')}\\n  <hr />\\n{/if}\\n\\n{#if component === ContentLinkRenderer}\\n  <svelte:component this={component} {node} />\\n{:else if component}\\n  {#if component !== ContentTextRenderer || !('text' in node) || node.text !== ''}\\n    <span {style} {id}>\\n      <svelte:component\\n        this={component}\\n        node={neverNode}\\n        {inline}\\n        {first}\\n        {last}\\n      />\\n    </span>\\n  {/if}\\n{:else if typeof node === 'object' && node && 'attachment' in node}\\n  <!-- render nothing -->\\n{:else}\\n  <span class=\\"phr-unknown\\">Unknown: {JSON.stringify(node)}</span>\\n{/if}\\n\\n{#if !inToc && typeof node === 'object' && node && 'pageBreak' in node && (node.pageBreak === 'after' || node.pageBreak === 'afterEven' || node.pageBreak === 'afterOdd')}\\n  <hr />\\n{/if}\\n\\n<style>\\n  span {\\n    background: var(--background);\\n    /* text would probably be better, but browser support is still bad */\\n    background-clip: content-box;\\n  }\\n\\n  hr {\\n    margin: 24pt 0;\\n  }\\n\\n  .phr-unknown {\\n    color: red;\\n  }\\n</style>\\n"],"names":[],"mappings":"AAyDE,eAAK,CACH,UAAU,CAAE,IAAI,YAAY,CAAC,CAE7B,eAAe,CAAE,WACnB,CAEA,aAAG,CACD,MAAM,CAAE,IAAI,CAAC,CACf,CAEA,uBAAa,CACX,KAAK,CAAE,GACT"}`
};
const ContentRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let style;
  let component;
  let id;
  let neverNode;
  let $nodes, $$unsubscribe_nodes;
  let $document, $$unsubscribe_document;
  let { node } = $$props;
  let { inline = false } = $$props;
  let { inToc = false } = $$props;
  let { inLink = false } = $$props;
  let { overrideStyle = void 0 } = $$props;
  let { first = void 0 } = $$props;
  let { last = void 0 } = $$props;
  const document = getDocument();
  $$unsubscribe_document = subscribe(document, (value) => $document = value);
  const nodes = getDocumentNodes();
  $$unsubscribe_nodes = subscribe(nodes, (value) => $nodes = value);
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  if ($$props.inline === void 0 && $$bindings.inline && inline !== void 0) $$bindings.inline(inline);
  if ($$props.inToc === void 0 && $$bindings.inToc && inToc !== void 0) $$bindings.inToc(inToc);
  if ($$props.inLink === void 0 && $$bindings.inLink && inLink !== void 0) $$bindings.inLink(inLink);
  if ($$props.overrideStyle === void 0 && $$bindings.overrideStyle && overrideStyle !== void 0) $$bindings.overrideStyle(overrideStyle);
  if ($$props.first === void 0 && $$bindings.first && first !== void 0) $$bindings.first(first);
  if ($$props.last === void 0 && $$bindings.last && last !== void 0) $$bindings.last(last);
  $$result.css.add(css$2);
  style = overrideStyle !== null && overrideStyle !== void 0 ? overrideStyle : getContentStyleString(node, $document, inline);
  component = getContentRenderer(node, inLink);
  id = typeof node === "object" && node && !inToc ? "tocItem" in node ? getTocTarget(node, $nodes) : "id" in node ? node.id : void 0 : void 0;
  neverNode = node;
  $$unsubscribe_nodes();
  $$unsubscribe_document();
  return `${!inToc && typeof node === "object" && node && "pageBreak" in node && (node.pageBreak === "before" || node.pageBreak === "beforeEven" || node.pageBreak === "beforeOdd") ? `<hr class="phr-n9gkpl">` : ``} ${component === ContentLinkRenderer ? `${validate_component(component || missing_component, "svelte:component").$$render($$result, { node }, {}, {})}` : `${component ? `${component !== ContentTextRenderer || !("text" in node) || node.text !== "" ? `<span${add_attribute("style", style, 0)}${add_attribute("id", id, 0)} class="phr-n9gkpl">${validate_component(component || missing_component, "svelte:component").$$render($$result, { node: neverNode, inline, first, last }, {}, {})}</span>` : ``}` : `${typeof node === "object" && node && "attachment" in node ? `` : `<span class="phr-unknown phr-n9gkpl">Unknown: ${escape(JSON.stringify(node))}</span>`}`}`} ${!inToc && typeof node === "object" && node && "pageBreak" in node && (node.pageBreak === "after" || node.pageBreak === "afterEven" || node.pageBreak === "afterOdd") ? `<hr class="phr-n9gkpl">` : ``}`;
});
const HeaderFooterRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let content;
  let $document, $$unsubscribe_document;
  const document = getDocument();
  $$unsubscribe_document = subscribe(document, (value) => $document = value);
  let { node } = $$props;
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  content = typeof node === "function" ? node(1, 1, getPageSize($document)) : node;
  $$unsubscribe_document();
  return `${content ? `${validate_component(ContentRenderer, "ContentRenderer").$$render($$result, { node: content }, {}, {})}` : ``}`;
});
function getHeaderHeight(document) {
  if (Array.isArray(document.pageMargins)) {
    if (document.pageMargins.length >= 4) {
      return document.pageMargins[1] + "pt";
    } else {
      return document.pageMargins[0] + "pt";
    }
  }
  return "40pt";
}
function getFooterHeight(document) {
  if (Array.isArray(document.pageMargins)) {
    if (document.pageMargins.length >= 4) {
      return document.pageMargins[3] + "pt";
    } else {
      return document.pageMargins[1] + "pt";
    }
  }
  return "40pt";
}
const BackgroundRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let content;
  let $document, $$unsubscribe_document;
  const document = getDocument();
  $$unsubscribe_document = subscribe(document, (value) => $document = value);
  let { node } = $$props;
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  content = typeof node === "function" ? node(1, getPageSize($document)) : node;
  $$unsubscribe_document();
  return `${content ? `${validate_component(ContentRenderer, "ContentRenderer").$$render($$result, { node: content }, {}, {})}` : ``}`;
});
function getWatermarkStyleString(node, document) {
  var _a, _b;
  const { width, height } = getPageSize(document);
  const defaultAngle = Math.atan(height / width);
  const defaultDiagonal = Math.sqrt(width * width + height * height);
  const numCharacters = typeof node === "string" ? node.length : (_b = (_a = node.text) == null ? void 0 : _a.length) != null ? _b : 0;
  const angle = typeof node === "object" && node && node.angle !== void 0 ? (360 - node.angle) * Math.PI / 180 : defaultAngle;
  const diagonal = Math.min(Math.abs(width / Math.cos(angle)), defaultDiagonal);
  const fontSize = diagonal / (numCharacters + 5) * 1.75;
  const style = {
    "font-size": fontSize + "pt",
    margin: `0 -${(diagonal - width) / 2}pt`,
    top: height / 2 - fontSize + "pt",
    transform: `rotate(-${angle}rad)`
  };
  if (typeof node === "object" && node) {
    if (node.fontSize) {
      style["font-size"] = node.fontSize + "pt";
      style["--font-size"] = node.fontSize + "pt";
    }
    if (node.font) style["font-family"] = node.font;
    if (node.bold) style["font-weight"] = "bold";
    if (node.italics) style["font-style"] = "italic";
    if (node.color) style["color"] = node.color;
    if (node.opacity) style["opacity"] = String(node.opacity);
  }
  return getStyleString(style);
}
const css$1 = {
  code: ".phr-watermark.phr-19lfqth{position:absolute;left:0;right:0;text-align:center;color:#000;opacity:0.6;white-space:nowrap;z-index:2;pointer-events:none}",
  map: `{"version":3,"file":"WatermarkRenderer.svelte","sources":["WatermarkRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">import { getDocument } from '../context';\\nimport { getWatermarkStyleString } from '../styling/watermark';\\nexport let node;\\n$: text = typeof node === 'object' && node ? node.text : node;\\nconst document = getDocument();\\n<\/script>\\n\\n<span class=\\"phr-watermark\\" style={getWatermarkStyleString(node, $document)}>\\n  {text ?? ''}\\n</span>\\n\\n<style>\\n  .phr-watermark {\\n    position: absolute;\\n    left: 0;\\n    right: 0;\\n    text-align: center;\\n    color: #000;\\n    opacity: 0.6;\\n    white-space: nowrap;\\n    z-index: 2;\\n    /* click through */\\n    pointer-events: none;\\n  }\\n</style>\\n"],"names":[],"mappings":"AAYE,0BAAe,CACb,QAAQ,CAAE,QAAQ,CAClB,IAAI,CAAE,CAAC,CACP,KAAK,CAAE,CAAC,CACR,UAAU,CAAE,MAAM,CAClB,KAAK,CAAE,IAAI,CACX,OAAO,CAAE,GAAG,CACZ,WAAW,CAAE,MAAM,CACnB,OAAO,CAAE,CAAC,CAEV,cAAc,CAAE,IAClB"}`
};
const WatermarkRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let text;
  let $document, $$unsubscribe_document;
  let { node } = $$props;
  const document = getDocument();
  $$unsubscribe_document = subscribe(document, (value) => $document = value);
  if ($$props.node === void 0 && $$bindings.node && node !== void 0) $$bindings.node(node);
  $$result.css.add(css$1);
  text = typeof node === "object" && node ? node.text : node;
  $$unsubscribe_document();
  return `<span class="phr-watermark phr-19lfqth"${add_attribute("style", getWatermarkStyleString(node, $document), 0)}>${escape(text != null ? text : "")} </span>`;
});
const css = {
  code: ".phr-container.phr-1uvfz6j{max-width:100%}.phr-page.phr-1uvfz6j{position:relative;display:flex;flex-direction:column;margin:auto;box-sizing:border-box;background:#fff;font-family:Roboto, Helvetica, sans-serif;font-size:12pt;--font-size:12pt;font-weight:normal;font-style:normal;line-height:normal;letter-spacing:normal;text-decoration:none;overflow:hidden}.phr-pageShadow.phr-1uvfz6j{box-shadow:0 0 2em #333}.phr-header.phr-1uvfz6j{position:absolute;top:0;left:0;right:0;overflow:hidden}.phr-pageContent.phr-1uvfz6j{position:relative;flex:1 1 auto;z-index:1}.phr-footer.phr-1uvfz6j{position:absolute;bottom:0;left:0;right:0;overflow:hidden}.phr-backgroundLayer.phr-1uvfz6j{position:absolute;top:0;left:0;right:0}",
  map: `{"version":3,"file":"DocumentRenderer.svelte","sources":["DocumentRenderer.svelte"],"sourcesContent":["<script lang=\\"ts\\">import ContentRenderer from './ContentRenderer.svelte';\\nimport { getPageStyleString, getPageContentStyleString, } from '../styling/page';\\nimport HeaderFooterRenderer from './HeaderFooterRenderer.svelte';\\nimport { getFooterHeight, getHeaderHeight } from '../styling/header';\\nimport BackgroundRenderer from './BackgroundRenderer.svelte';\\nimport WatermarkRenderer from './WatermarkRenderer.svelte';\\nexport let document;\\nexport let pageShadow;\\nexport let mode;\\nlet clientWidth;\\n<\/script>\\n\\n<div bind:clientWidth class=\\"phr-container\\">\\n  <div\\n    class=\\"phr-page\\"\\n    class:phr-pageShadow={pageShadow}\\n    style={getPageStyleString(document, clientWidth, mode)}\\n  >\\n    {#if document.background}\\n      <div class=\\"phr-backgroundLayer\\">\\n        <BackgroundRenderer node={document.background} />\\n      </div>\\n    {/if}\\n    <div class=\\"phr-pageContent\\" style={getPageContentStyleString(document)}>\\n      {#if document.header}\\n        <div class=\\"phr-header\\" style=\\"height: {getHeaderHeight(document)}\\">\\n          <HeaderFooterRenderer node={document.header} />\\n        </div>\\n      {/if}\\n      {#if document.content}\\n        <ContentRenderer node={document.content} />\\n      {/if}\\n      {#if document.footer}\\n        <div class=\\"phr-footer\\" style=\\"height: {getFooterHeight(document)}\\">\\n          <HeaderFooterRenderer node={document.footer} />\\n        </div>\\n      {/if}\\n      {#if document.watermark}\\n        <WatermarkRenderer node={document.watermark} />\\n      {/if}\\n    </div>\\n  </div>\\n</div>\\n\\n<style>\\n  .phr-container {\\n    max-width: 100%;\\n  }\\n  .phr-page {\\n    position: relative;\\n    display: flex;\\n    flex-direction: column;\\n    margin: auto;\\n    box-sizing: border-box;\\n    background: #fff;\\n    font-family: Roboto, Helvetica, sans-serif;\\n    font-size: 12pt;\\n    --font-size: 12pt;\\n    font-weight: normal;\\n    font-style: normal;\\n    line-height: normal;\\n    letter-spacing: normal;\\n    text-decoration: none;\\n    overflow: hidden;\\n  }\\n  .phr-pageShadow {\\n    box-shadow: 0 0 2em #333;\\n  }\\n  .phr-header {\\n    position: absolute;\\n    top: 0;\\n    left: 0;\\n    right: 0;\\n    overflow: hidden;\\n  }\\n  .phr-pageContent {\\n    position: relative;\\n    flex: 1 1 auto;\\n    z-index: 1;\\n  }\\n  .phr-footer {\\n    position: absolute;\\n    bottom: 0;\\n    left: 0;\\n    right: 0;\\n    overflow: hidden;\\n  }\\n  .phr-backgroundLayer {\\n    position: absolute;\\n    top: 0;\\n    left: 0;\\n    right: 0;\\n  }\\n</style>\\n"],"names":[],"mappings":"AA6CE,0BAAe,CACb,SAAS,CAAE,IACb,CACA,qBAAU,CACR,QAAQ,CAAE,QAAQ,CAClB,OAAO,CAAE,IAAI,CACb,cAAc,CAAE,MAAM,CACtB,MAAM,CAAE,IAAI,CACZ,UAAU,CAAE,UAAU,CACtB,UAAU,CAAE,IAAI,CAChB,WAAW,CAAE,MAAM,CAAC,CAAC,SAAS,CAAC,CAAC,UAAU,CAC1C,SAAS,CAAE,IAAI,CACf,WAAW,CAAE,IAAI,CACjB,WAAW,CAAE,MAAM,CACnB,UAAU,CAAE,MAAM,CAClB,WAAW,CAAE,MAAM,CACnB,cAAc,CAAE,MAAM,CACtB,eAAe,CAAE,IAAI,CACrB,QAAQ,CAAE,MACZ,CACA,2BAAgB,CACd,UAAU,CAAE,CAAC,CAAC,CAAC,CAAC,GAAG,CAAC,IACtB,CACA,uBAAY,CACV,QAAQ,CAAE,QAAQ,CAClB,GAAG,CAAE,CAAC,CACN,IAAI,CAAE,CAAC,CACP,KAAK,CAAE,CAAC,CACR,QAAQ,CAAE,MACZ,CACA,4BAAiB,CACf,QAAQ,CAAE,QAAQ,CAClB,IAAI,CAAE,CAAC,CAAC,CAAC,CAAC,IAAI,CACd,OAAO,CAAE,CACX,CACA,uBAAY,CACV,QAAQ,CAAE,QAAQ,CAClB,MAAM,CAAE,CAAC,CACT,IAAI,CAAE,CAAC,CACP,KAAK,CAAE,CAAC,CACR,QAAQ,CAAE,MACZ,CACA,gCAAqB,CACnB,QAAQ,CAAE,QAAQ,CAClB,GAAG,CAAE,CAAC,CACN,IAAI,CAAE,CAAC,CACP,KAAK,CAAE,CACT"}`
};
const DocumentRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let { document } = $$props;
  let { pageShadow } = $$props;
  let { mode } = $$props;
  let clientWidth;
  if ($$props.document === void 0 && $$bindings.document && document !== void 0) $$bindings.document(document);
  if ($$props.pageShadow === void 0 && $$bindings.pageShadow && pageShadow !== void 0) $$bindings.pageShadow(pageShadow);
  if ($$props.mode === void 0 && $$bindings.mode && mode !== void 0) $$bindings.mode(mode);
  $$result.css.add(css);
  return `<div class="phr-container phr-1uvfz6j"><div class="${["phr-page phr-1uvfz6j", pageShadow ? "phr-pageShadow" : ""].join(" ").trim()}"${add_attribute("style", getPageStyleString(document, clientWidth, mode), 0)}>${document.background ? `<div class="phr-backgroundLayer phr-1uvfz6j">${validate_component(BackgroundRenderer, "BackgroundRenderer").$$render($$result, { node: document.background }, {}, {})}</div>` : ``} <div class="phr-pageContent phr-1uvfz6j"${add_attribute("style", getPageContentStyleString(document), 0)}>${document.header ? `<div class="phr-header phr-1uvfz6j" style="${"height: " + escape(getHeaderHeight(document), true)}">${validate_component(HeaderFooterRenderer, "HeaderFooterRenderer").$$render($$result, { node: document.header }, {}, {})}</div>` : ``} ${document.content ? `${validate_component(ContentRenderer, "ContentRenderer").$$render($$result, { node: document.content }, {}, {})}` : ``} ${document.footer ? `<div class="phr-footer phr-1uvfz6j" style="${"height: " + escape(getFooterHeight(document), true)}">${validate_component(HeaderFooterRenderer, "HeaderFooterRenderer").$$render($$result, { node: document.footer }, {}, {})}</div>` : ``} ${document.watermark ? `${validate_component(WatermarkRenderer, "WatermarkRenderer").$$render($$result, { node: document.watermark }, {}, {})}` : ``}</div></div> </div>`;
});
const subscriber_queue = [];
function writable(value, start = noop) {
  let stop;
  const subscribers = /* @__PURE__ */ new Set();
  function set(new_value) {
    if (safe_not_equal(value, new_value)) {
      value = new_value;
      if (stop) {
        const run_queue = !subscriber_queue.length;
        for (const subscriber of subscribers) {
          subscriber[1]();
          subscriber_queue.push(subscriber, value);
        }
        if (run_queue) {
          for (let i = 0; i < subscriber_queue.length; i += 2) {
            subscriber_queue[i][0](subscriber_queue[i + 1]);
          }
          subscriber_queue.length = 0;
        }
      }
    }
  }
  function update(fn) {
    set(fn(value));
  }
  function subscribe2(run2, invalidate = noop) {
    const subscriber = [run2, invalidate];
    subscribers.add(subscriber);
    if (subscribers.size === 1) {
      stop = start(set, update) || noop;
    }
    run2(value);
    return () => {
      subscribers.delete(subscriber);
      if (subscribers.size === 0 && stop) {
        stop();
        stop = null;
      }
    };
  }
  return { set, update, subscribe: subscribe2 };
}
const PdfmakeHtmlRenderer = create_ssr_component(($$result, $$props, $$bindings, slots) => {
  let { document } = $$props;
  let { pageShadow = true } = $$props;
  let { mode = "shrinkToFit" } = $$props;
  const documentStore = writable(document);
  const nodesStore = writable(flattenNodes(document === null || document === void 0 ? void 0 : document.content));
  setContext(contextKey, {
    document: documentStore,
    nodes: nodesStore
  });
  if ($$props.document === void 0 && $$bindings.document && document !== void 0) $$bindings.document(document);
  if ($$props.pageShadow === void 0 && $$bindings.pageShadow && pageShadow !== void 0) $$bindings.pageShadow(pageShadow);
  if ($$props.mode === void 0 && $$bindings.mode && mode !== void 0) $$bindings.mode(mode);
  {
    documentStore.set(document);
  }
  {
    nodesStore.set(flattenNodes(document === null || document === void 0 ? void 0 : document.content));
  }
  return `${document ? `${validate_component(DocumentRenderer, "DocumentRenderer").$$render($$result, { document, pageShadow, mode }, {}, {})}` : ``}`;
});
exports.PdfmakeHtmlRenderer = PdfmakeHtmlRenderer;
exports.default = PdfmakeHtmlRenderer;
