function getNodeText(node) {
    if (!node)
        return '';
    if (typeof node === 'string' || typeof node === 'number')
        return String(node);
    if (Array.isArray(node))
        return node.map(getNodeText).join('');
    if ('text' in node && node.text)
        return getNodeText(node.text);
    return '';
}
export function getReferencedNode(reference, nodes) {
    return nodes.find(node => typeof node === 'object' && node && 'id' in node && node.id === reference);
}
export function getReferenceText(reference, nodes) {
    const node = getReferencedNode(reference, nodes);
    if (!node)
        return '';
    return getNodeText(node);
}
