import type { Content, ContentTable, TableCell } from 'pdfmake/interfaces';
export type ActualTableCell = Content & {
    rowSpan?: number;
    colSpan?: number;
    border?: [boolean, boolean, boolean, boolean];
    borderColor?: [string, string, string, string];
    fillOpacity?: number;
};
export declare function isActualTableCell(cell: TableCell): cell is ActualTableCell;
/**
 * Returns a set of `rowIndex-columnIndex` keys for cells that are covered
 * by the `colSpan` and/or `rowSpan` of another cell.
 *
 * pdfmake forces us to put "empty" cells there, but then ignores them.
 */
export declare function getTableCellsCoveredBySpans(node: ContentTable): Set<string>;
export declare function shouldRenderCell(cell: TableCell, rowIndex: number, columnIndex: number, coveredCells: Set<string>): cell is ActualTableCell;
