export function getStyleProperty(property, style, document) {
    var _a, _b, _c;
    if (typeof style === 'string') {
        const documentStyle = (_a = document.styles) === null || _a === void 0 ? void 0 : _a[style];
        if ((documentStyle === null || documentStyle === void 0 ? void 0 : documentStyle[property]) !== undefined)
            return documentStyle[property];
    }
    else if (Array.isArray(style)) {
        for (const styleOrNameName of [...style].reverse()) {
            if (typeof styleOrNameName === 'object') {
                if (styleOrNameName[property] !== undefined)
                    return styleOrNameName[property];
            }
            else {
                const documentStyle = (_b = document.styles) === null || _b === void 0 ? void 0 : _b[styleOrNameName];
                if ((documentStyle === null || documentStyle === void 0 ? void 0 : documentStyle[property]) !== undefined)
                    return documentStyle[property];
            }
        }
    }
    else if (typeof style === 'object' && style) {
        if (style[property] !== undefined)
            return style[property];
    }
    if (((_c = document.defaultStyle) === null || _c === void 0 ? void 0 : _c[property]) !== undefined)
        return document.defaultStyle[property];
    return undefined;
}
