export function getMarginString(margins, defaultMargin = 0) {
    if (!margins)
        return defaultMargin + 'pt';
    if (Array.isArray(margins)) {
        if (margins.length >= 4) {
            const [left, top, right, bottom] = margins;
            return [top, right, bottom, left].map(it => (it !== null && it !== void 0 ? it : 0) + 'pt').join(' ');
        }
        else {
            const [horizontal, vertical] = margins;
            return [vertical, horizontal].map(it => (it !== null && it !== void 0 ? it : 0) + 'pt').join(' ');
        }
    }
    return margins + 'pt';
}
export function getMarginStringFromStyle(style) {
    var _a, _b, _c, _d;
    if (style.margin !== undefined) {
        return getMarginString(style.margin);
    }
    const margins = [
        (_a = style.marginLeft) !== null && _a !== void 0 ? _a : 0,
        (_b = style.marginTop) !== null && _b !== void 0 ? _b : 0,
        (_c = style.marginRight) !== null && _c !== void 0 ? _c : 0,
        (_d = style.marginBottom) !== null && _d !== void 0 ? _d : 0,
    ];
    if (margins.some(it => it !== 0)) {
        return getMarginString(margins);
    }
    return undefined;
}
