import { getStyleString } from './utils';
export function getQrStyleString(node, src) {
    var _a;
    const style = {};
    // we roughly try to match pdfmake's sizing
    const defaultZoom = 5;
    const naturalWidth = parseInt(decodeURIComponent(src).match(/viewBox="0 0 (\d+) (\d+)"/i)[1]) *
        defaultZoom;
    const naturalPadding = ((_a = node.padding) !== null && _a !== void 0 ? _a : 0) * defaultZoom;
    if (node.fit) {
        const padding = naturalPadding * (node.fit / naturalWidth);
        Object.assign(style, {
            // pdfmake seems to shrink the QR code by certain fixed factors and is often actually smaller
            width: node.fit + 'pt',
            height: node.fit + 'pt',
            padding: padding + 'pt',
        });
    }
    else {
        Object.assign(style, {
            width: naturalWidth + 'pt',
            height: naturalWidth + 'pt',
            padding: naturalPadding + 'pt',
        });
    }
    return getStyleString(style);
}
