import { getMarginString } from './margin';
import { getStyleDictionary } from './style';
import { getStyleString } from './utils';
export function getTocItemStyleString(node, tocNode, document) {
    var _a, _b;
    // styles on the node itself seem to replace the styles on the ToC completely
    const textStyle = (_a = node.tocStyle) !== null && _a !== void 0 ? _a : tocNode.toc.textStyle;
    const margin = (_b = node.tocMargin) !== null && _b !== void 0 ? _b : tocNode.toc.textMargin;
    const style = {
        display: 'block',
        padding: getMarginString(margin),
    };
    const applyBaseStyle = (nameOrStyle) => {
        var _a;
        if (typeof nameOrStyle === 'object') {
            Object.assign(style, nameOrStyle);
            return;
        }
        const baseStyle = (_a = document.styles) === null || _a === void 0 ? void 0 : _a[nameOrStyle];
        if (baseStyle) {
            Object.assign(style, getStyleDictionary(baseStyle));
        }
    };
    if (textStyle) {
        if (typeof textStyle === 'string') {
            applyBaseStyle(textStyle);
        }
        else if (Array.isArray(textStyle)) {
            textStyle.forEach(applyBaseStyle);
        }
        else {
            Object.assign(style, getStyleDictionary(textStyle));
        }
    }
    return getStyleString(style);
}
