import cssColorNames from './css-color-names';
export function getStyleString(styles) {
    return Object.entries(styles)
        .map(([key, value]) => `${key}: ${value}`)
        .join('; ');
}
export function colorToHex(color) {
    var _a;
    if (color === 'transparent')
        return undefined;
    if (!color || color.startsWith('#'))
        return color;
    return (_a = cssColorNames[color]) !== null && _a !== void 0 ? _a : undefined;
}
export function colorToRgb(color) {
    // We ignore tiling patterns (arrays)
    if (!color || Array.isArray(color) || color === 'transparent')
        return undefined;
    const hexColor = colorToHex(color);
    if (!hexColor)
        return undefined;
    return [
        parseInt(hexColor.slice(1, 3), 16),
        parseInt(hexColor.slice(3, 5), 16),
        parseInt(hexColor.slice(5), 16),
    ];
}
export function opacityColor(color, opacity) {
    // We ignore tiling patterns (arrays)
    if (color == null || Array.isArray(color))
        return undefined;
    if (opacity == null || opacity == 1)
        return color;
    if (opacity == 0)
        return 'transparent';
    const rgb = colorToRgb(color);
    if (!rgb)
        return color;
    return `rgba(${rgb.join(', ')}, ${opacity})`;
}
